// DemoVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoVC.h"
#include "DemoVCDlg.h"
#include "ucalc.cpp"
#include <winbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


long OtherProperties;
double W, H;
void PopulateComboBoxes(CComboBox* Combo1, CComboBox* Combo2, CComboBox* Combo3, CComboBox* Combo4);
void CartesianLineTo(CDC* pDC, double X, double Y);
double _stdcall ucalcAverage(ucThreadType& t);
double _stdcall ucalcSum(ucThreadType& t);
double _stdcall ucArraySum(ucThreadType& t);
long _stdcall ErrorHandler(ucThreadType& t);

/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg dialog

CDemoVCDlg::CDemoVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoVCDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


  ucEvalStr("Initialize the parser class");

  ucDefineConstant("Div0 = 4");  // Div0 = ucFPU_ErrMask_ZeroDivide;
  ucDefineFunction("Average()", ucalcAverage);
  ucDefineFunction("ArraySum(Values())", ucArraySum);
  ucDefineFunction("Sum(Expr&,start,finish,step=1,var@=x)", ucalcSum);
  ucErrorHandler(ErrorHandler);

  OtherProperties = ucOverload + ucComplex + ucRecursion + ucOverwrite + ucOverride;
  t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties; 
}

void PopulateComboBoxes(CComboBox* Combo1, CComboBox* Combo2, CComboBox* Combo3, CComboBox* Combo4)
{
  Combo1->SetWindowText("3+4/5-8");
  Combo1->AddString("3+4/5-8");
  Combo1->AddString("5*(((10+3)!-1) MOD 7)^2");
  Combo1->AddString("#b101.1101 + #b110.1001");
  Combo1->AddString("(3+4#i)^2");
  Combo1->AddString("Sqr(-1)");
  Combo1->AddString("\"This\" > \"That\"");
  Combo1->AddString("\"This\" < \"That\"");
  Combo1->AddString("1/0");
  Combo1->AddString("SetOrFPU(Div0, -1/0)");
  Combo1->AddString("SetXorFPU(Div0, -1/0)");
  Combo1->AddString("");
  Combo1->AddString("// -- sum() and average() are defined in");
  Combo1->AddString("// -- the source code.  See DEMOCPP.CPP.");
  Combo1->AddString("sum(x^2+5,1,10)");
  Combo1->AddString("sum(2y-3,1,10,,y)");
  Combo1->AddString("sum(x+10,2,5,.5)");
  Combo1->AddString("average(5,min(2,5),8)-max(2,5,9,1)");
  Combo1->AddString("");

  Combo2->SetWindowText("MyVariable = 100");
  Combo2->AddString("MyVariable = 100");
  Combo2->AddString("MyString = 'This is my string' ");
  Combo2->AddString("i = #i");
  Combo2->AddString("Price As Currency = 137.25");
  Combo2->AddString("MyArray(): Double = {57, 23, 98, 17, 46}");  
  Combo2->AddString("");

  Combo3->SetWindowText("fract(x)=abs(abs(x)-int(abs(x)))");
  Combo3->AddString("fract(x)=abs(abs(x)-int(abs(x)))");
  Combo3->AddString("concat$(txtA$,txtB$) = txtA+txtB");
  Combo3->AddString("TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)");
  Combo3->AddString("");
  Combo3->AddString("// -- Overloading a function with 2 definitions");
  Combo3->AddString("area(length,width)=length*width");
  Combo3->AddString("area(side) = side^2");
  Combo3->AddString("");
  Combo3->AddString("// -- Function with optional argument");
  Combo3->AddString("volume(r,h=0)=iif(h=0,pi*r^3*4/3,pi*r^2*h/3)");
  Combo3->AddString("");
  Combo3->AddString("// -- Recursive function definition");
  Combo3->AddString("Factorial(x) = iif(x=0, 1, x*Factorial(x-1))");
  Combo3->AddString("");
  Combo3->AddString("// -- Operator definitions");
  Combo3->AddString("Note: shl may have already been defined by add-on");
  Combo3->AddString("shl[x,y]      =      x * 2^y");
  Combo3->AddString("![x]            =      x == 0");
  Combo3->AddString("!=[x,y]       =      x <> y");
  Combo3->AddString("");
  Combo3->AddString("// -- Macro definitions");
  Combo3->AddString("Macro MyMacro(x, y) = x + y");
  Combo3->AddString("Macro [x]~ = x!");
  Combo3->AddString("");
  Combo3->AddString("// -- Complex # function definition");
  Combo3->AddString("cnj(x)= x.Real + (-x.Imag)*#i");

  Combo4->SetWindowText("fract(150/17)+MyVariable");
  Combo4->AddString("fract(150/17)+MyVariable");
  Combo4->AddString("area(4)+area(5,10)+max(5,9,3)");
  Combo4->AddString("volume(4)+volume(4,5)");
  Combo4->AddString("2*cnj(3+4#i)");
  Combo4->AddString("ArraySum(MyArray())");
  Combo4->AddString("Sum(MyArray(x),1,3)");
  Combo4->AddString("MyMacro(3, 4)~");
  Combo4->AddString("");
  Combo4->AddString("// -- Note: Some functions such");
  Combo4->AddString("// -- as Sum(), ArraySum() and others");
  Combo4->AddString("// -- are defined at the source code level.");
}

void CDemoVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoVCDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoVCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoVCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_EDITCHANGE(IDC_COMBO2, OnEditchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg message handlers

BOOL CDemoVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
    
	CheckDlgButton(IDC_CHECK1, BST_CHECKED);
	SetDlgItemText(IDC_EDIT1, "(result)");
    SetDlgItemText(IDC_EDIT2, "-sin(x)/2");
	SetDlgItemText(IDC_EDIT3, "(result)");
	SetDlgItemText(IDC_EDIT4, "1000000");
	SetDlgItemText(IDC_EDIT5, "x^2 + 5x - 10");

    CComboBox* Combo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);
    CComboBox* Combo2 = (CComboBox*)GetDlgItem(IDC_COMBO2);
    CComboBox* Combo3 = (CComboBox*)GetDlgItem(IDC_COMBO3);
    CComboBox* Combo4 = (CComboBox*)GetDlgItem(IDC_COMBO4);

    PopulateComboBoxes(Combo1, Combo2, Combo3, Combo4);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoVCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoVCDlg::OnEditchangeCombo2() 
{
	// TODO: Add your control notification handler code here
	
}

void CDemoVCDlg::OnButton1() 
{
	char MyText[80];

	GetDlgItemText(IDC_COMBO1, MyText, 80);
	SetDlgItemText(IDC_EDIT1, ucEvalStr(MyText));
}

void CDemoVCDlg::OnButton2() 
{
	char MyText[80];

	GetDlgItemText(IDC_COMBO2, MyText, 80);
	ucDefineVariable(MyText);	
}

void CDemoVCDlg::OnButton4() 
{
    char MyText[80];

	GetDlgItemText(IDC_COMBO3, MyText, 80);
	ucDefineFunction(MyText);	
}

void CDemoVCDlg::OnButton5() 
{
    char MyText[80];

    GetDlgItemText(IDC_COMBO4, MyText, 80);
	SetDlgItemText(IDC_EDIT3, ucEvalStr(MyText));
}

double _stdcall ucalcSum(ucThreadType& t)
{
  DWORD ExpressionPtr;
  long VariableHandle;
  double x, sstep, Start, Finish, Total;

  ExpressionPtr  = (DWORD)ucParam(1, t);
  Start          = ucParam(2, t);
  Finish         = ucParam(3, t);
  sstep          = ucParam(4, t);
  VariableHandle = (long)ucParam(5, t);

  Total = 0;
  x = Start;  

  while (x <= Finish)
  {
    ucSetVariableValue(VariableHandle, x);
    Total = Total + ucEvaluate(ExpressionPtr);
    x = x + sstep;
  }

  return Total;
}

double _stdcall ucArraySum(ucThreadType& t)
{
    double *ValueArrayDbl;
    unsigned long BaseAddress;
    long ArrayHandle, UpperBound, x;
    double Total = 0;

    ArrayHandle = (long)ucParam(1, t);
    BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress);
    UpperBound  = ucArrayInfo(ArrayHandle, ucArray_ElementCount)-1;    

    ValueArrayDbl = (double *) BaseAddress;    

    for(x = 0; x <= UpperBound; x++)    
       Total = Total + ValueArrayDbl[x];       

    return Total;
}

double _stdcall ucalcAverage(ucThreadType& t)
{
  long x;
  double Total = 0;

  for(x = 1; x <= t.ParamCount; x++)
    Total = Total + ucParam(x, t);

  return Total / t.ParamCount;
}

long _stdcall ErrorHandler(ucThreadType& t)
{
   char ErrorMessage[80];

   if (t.Context & ucContext_ucParseOrucEval) {
      strcpy(ErrorMessage, ucErrorMessage(t.ErrorNumber, t.ucThread));
      strcat(ErrorMessage, "\nData: ");
      if (ucErrorData(0, t.ucThread) != NULL)
         strcat(ErrorMessage, ucErrorData(0, t.ucThread));
      AfxMessageBox(ErrorMessage, MB_OK);
   }
   return 0;
}

void CartesianLineTo(CDC* pDC, double X, double Y)
{
  int x, y;
  CRect rect;  

  x = (long)(W * (X + 10) / 20);
  y = (long)(H * (2 - Y) / 4);

  if (X == -10 || y > H || y < 0)
  pDC->MoveTo((long)x, (long)min(max(y, 0), H));
  else pDC->LineTo(x, y);  
}

void CDemoVCDlg::OnButton3() 
{
  double x = -10;
  long UserEq;
  char MyText[80];
  CRect rect;

  CWnd* h = GetDlgItem(IDC_PICTURE1);
  h->GetClientRect(rect);
  CDC* pDC = h->GetDC();
  
  GetDlgItemText(IDC_EDIT2, MyText, 80);

  h->GetClientRect(rect);
  pDC->FillRect(rect, CBrush::FromHandle((HBRUSH)GetStockObject(LTGRAY_BRUSH)));
  UserEq = ucParse(MyText, "x");
  ucAttachVariable("x", &x, UserEq);

  W = rect.Width();
  H = rect.Height();

  pDC->MoveTo(0, (long)H/2);

  while (x <= 10)
  {
    CartesianLineTo(pDC, x, ucEvaluate(UserEq));
    x = x + 0.125;
  }

  ucReleaseExprPtr(UserEq);	
  h->ReleaseDC(pDC);
}

void CDemoVCDlg::OnButton6() 
{
  char Total[80], MiscText[80], Elapsed[80]; 
  double x = 1, Sum = 0;
  long UserEq, finalValue, TimerStart, TimerFinish;

  TimerStart = GetTickCount();

  GetDlgItemText(IDC_EDIT4, MiscText, 80);
  finalValue = atoi(MiscText);

  GetDlgItemText(IDC_EDIT5, MiscText, 80);
  UserEq = ucParse(MiscText, "x");
  ucAttachVariable("x", &x, UserEq);

  if (IsDlgButtonChecked(IDC_CHECK2) != 0)
     t0.ucProperty.FPU_Turbo = ucFPU_SkipSet + ucFPU_SkipReset;

  while (x <= finalValue)
  {
    Sum = Sum + ucEvaluate(UserEq);
    x++;
  }

  TimerFinish = GetTickCount();
  gcvt(Sum, 15, Total);
  gcvt((float)(TimerFinish-TimerStart)/(float)1000, 15, Elapsed);
  strcpy(MiscText, Elapsed);
  strcat(MiscText, "  sec  ");
  strcat(MiscText, Total);
  SetDlgItemText(IDC_EDIT6, MiscText);

  ucReleaseExprPtr(UserEq);
}

void CDemoVCDlg::OnCheck1() 
{
  if (IsDlgButtonChecked(IDC_CHECK1) != 0)
     t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties;
  else
     t0.ucProperty.FunctionProperties = ucInline + OtherProperties;	   
}

void CDemoVCDlg::OnCheck2() 
{
	// See CDemoVCDlg::OnButton6()
	
}
