Option Strict Off
Option Explicit On 

Public Module UCalc
    Friend FastMath_definst As New FastMath
    Friend ucVbLibucVbLibrary_definst As New ucVbLib.ucVbLibrary
    ' -------------------------------------------------------------------------
    ' ucalcvb.vb : Module file
    ' Designed to work with VB.NET 2003 or above.
    '
    ' UCalc Fast Math Parser (Beta N)
    ' Copyright (c) 1998-2005 by Daniel Corbier.  All rights reserved.
    ' http://www.ucalc.com/mathparser
    ' -------------------------------------------------------------------------
#Const ucLibraryAddon = False
    ' +++ VB include needs major revision
    Public Structure ucDefinitionSpaceType
        Dim BaseDefinitionSpace As Integer
        Dim DefinitionSpace As Integer
        Dim InlineBuffer As Integer
        Dim MaxErrorData As Integer
        Dim MaxThreadCount As Integer
    End Structure

    Public Structure ucForInternalUseType
        Dim LanguageID As Integer
        Dim ucOperator As Integer
        Dim ucEvalAddr As Integer
        Dim ucEvaluateAddr As Integer
        Dim ucThreadAddr As Integer
        Dim ParamListAddr As Integer
        Dim HandleAddr As Integer
        Dim ReleaseExprPtr As Integer
        Dim TreeIndex As Integer
        Dim TreeParamInfoAddress As Integer
        Dim HaltEvaluation As Integer
        Dim ThreadStatus As Integer
        Dim PrevOperationCount As Integer
        Dim PrevItemCount As Integer
        Dim CompareOld As Integer
        Dim IsStringValue As Integer
        Dim ucStack As Integer
        Dim Infinity As Integer
        Dim TrigFactor As Integer
        Dim TrigFactorInv As Integer
        Dim DataGroup1 As Integer
        Dim DataGroup1b As Integer
        Dim DataGroup1c As Integer
        Dim DataGroup2 As Integer
        Dim DataGroup2b As Integer
        Dim DataGroup2c As Integer
        Dim DataGroup3 As Integer
        Dim DataGroup3b As Integer
        Dim DataGroup3c As Integer
        Dim DataGroup4 As Integer
        Dim DataGroup4b As Integer
        Dim DataGroup4c As Integer
        Dim StringPtr1 As Integer
    End Structure

    Public Structure ucPropertyType
        Dim DefaultNumericType As Integer
        Dim DefaultExternalStringType As Integer
        Dim FPU_ControlWord_UCalc As Integer
        Dim FPU_ControlWord_HostProgram As Integer
        Dim FPU_Turbo As Integer
        Dim CaseSensitive As Integer
        Dim ComplexNumbers As Integer
        Dim ImagSymbol As Integer
        Dim RelationalTrue As Integer
        Dim ImplicitMultiply As Integer
        Dim MaxParamPerFunction As Integer
        Dim ArrayProperties As Integer
        Dim FunctionProperties As Integer
        Dim StackSize As Integer
        Dim DefaultPrecedence As Integer
        Dim OutputDigits As Integer
        Dim QuoteChar As Integer
        Dim QuoteCharSynonym As Integer
        Dim ArgumentSeparator As Integer
        Dim DecimalSeparator As Integer
        Dim EscapeChar As Integer
        Dim DefSpace As ucDefinitionSpaceType
    End Structure

    Public Structure ucHandleType
        Dim ucThread As Integer
        Dim Info As Integer
        Dim DataType As Integer
        Dim DataPtr As Integer
        Dim DataCplxPtr As Integer
        Dim SymbolName As Integer
        Dim SortedHandle As Integer
        Dim OverloadHandle As Integer
        Dim OpPrecedence As Integer
        Dim ParamCountHiLo As Integer ' Lo = ReqParamCount; Hi = ParamCount
        Dim CallbackPtr As Integer
        Dim FuncArgs As Integer
        Dim FuncArgHandleData As Integer
        Dim FuncArgTypeList As Integer
        Dim VarValueStr As Integer
        Dim DataGroup1 As Integer
        Dim DataGroup1b As Integer
        Dim DataGroup1c As Integer
        Dim DataGroup2 As Integer
        Dim DataGroup2b As Integer
        Dim DataGroup2c As Integer
        Dim StringPtr1 As Integer
        Dim StringPtr2 As Integer
        Dim StringPtr3 As Integer
        Dim StringPtr4 As Integer
        Dim StringPtr5 As Integer
        Dim UserData1 As Integer
        Dim UserData2 As Integer
        Dim UserData3 As Integer
        Dim UserData4 As Integer
    End Structure

    ' <StructLayout(LayoutKind.Sequential)> _
    Public Structure ucThreadType
        Dim ucThread As Integer
        Dim Context As Integer
        Dim ParamCount As Integer
        Dim ErrorNumber As Integer
        Dim TreeDirection As Integer
        Dim DefSpace As Integer
        Dim OperationCount As Integer
        Dim ItemCount As Integer
        Dim Sequence As Integer
        Dim SequenceLast As Integer
        Dim ExprHasChanged As Integer
        Dim IsFunctionParse As Integer
        Dim ComplexStatus As Integer
        Dim ucParamAddr As Integer
        Dim ucParamHandleAddr As Integer
        Dim SymbolStart As Integer
        Dim SymbolEnd As Integer
        Dim PrecedenceMax As Integer
        Dim PrecedenceMin As Integer
        Dim VarHandle As Integer
        Dim OpHandle As Integer
        Dim StringWasReturned As Integer
        Dim ReturnString As Integer
        Dim ReturnValue As Integer
        Dim ReturnComplex As Integer
        Dim ucProperty As ucPropertyType
        Dim Handshake As ucForInternalUseType
        Dim User1 As Integer
        Dim User2 As Integer
        Dim User3 As Integer
        Dim User4 As Integer
    End Structure

    Public Structure ucComplexNumberType
        Dim Real As Double
        Dim Imag As Double
    End Structure

    Public Const ucTrue As Short = 1
    Public Const ucFalse As Short = 0

    ' LanguageID
    Public Const uc_Lang_Unsupported As Short = 0
    Public Const uc_Lang_Debug As Short = 1
    Public Const uc_Lang_PowerBasic As Short = 2
    Public Const uc_Lang_Delphi As Short = 3
    Public Const uc_Lang_VisualBasic As Short = 4
    Public Const uc_Lang_VisualBasicNET As Short = 5
    Public Const uc_Lang_CPlusPlus As Short = 6

    ' Type constants for vType arg of ucDefineFunction and ucDefineVariable
    Public Const ucType_Integer8 As Short = 1
    Public Const ucType_Integer8u As Short = 2
    Public Const ucType_Integer16 As Short = 3
    Public Const ucType_Integer16u As Short = 4
    Public Const ucType_Integer32 As Short = 5
    Public Const ucType_Integer32u As Short = 6
    Public Const ucType_Integer64 As Short = 7
    Public Const ucType_Integer64u As Short = 8
    Public Const ucType_Currency As Short = 9
    Public Const ucType_CurrencyExt As Short = 10
    Public Const ucType_FloatSingle As Short = 11
    Public Const ucType_FloatDouble As Short = 12
    Public Const ucType_FloatExtended As Short = 13
    Public Const ucType_StringBSTR As Short = 14 ' For VB
    Public Const ucType_StringLPSTR As Short = 15 ' (ASCIIZ) C++ char default
    Public Const ucType_StringAnsi As Short = 16 ' PowerBASIC and Delphi default
    Public Const ucType_Any = 17

    Public Const ucType_Long As Short = ucType_Integer32
    Public Const ucType_Double As Short = ucType_FloatDouble
    Public Const ucType_Extended As Short = ucType_FloatExtended
    Public Const ucType_FixedPt As Short = ucType_Currency
    Public Const ucType_AnsiString As Short = ucType_StringAnsi

    ' Context options (t.Context)
    Public Const ucContext_Escape As Short = 1
    Public Const ucContext_Try As Short = 2
    Public Const ucContext_ucDefine As Short = 4
    Public Const ucContext_ucDefineFunction As Short = 8
    Public Const ucContext_ucDefineVariable As Short = 16
    Public Const ucContext_ucEval As Short = 32
    Public Const ucContext_ucEvalStr As Short = 64
    Public Const ucContext_ucEvaluateStr As Short = 128
    Public Const ucContext_ucParse As Short = 256
    Public Const ucContext_ucParseOrucEval As Short = 512
    Public Const ucContext_ucReset As Short = 1024
    Public Const ucContext_Reserved As Short = 2048

    ' For ucTreeProperty, ucTreeNodeProperty,
    ' ucTreeParamProperty, and ucTreeParentProperty
    Public Const ucIsInline As Short = 0
    Public Const ucIsDynamic As Short = 1
    Public Const ucIsFastCallback As Short = 2
    Public Const ucIsLocal As Short = 3
    Public Const ucIsComplex As Short = 4
    Public Const ucIsLocked As Short = 5
    Public Const ucIsConstant As Short = ucIsLocked
    Public Const ucIsOverride As Short = 6
    Public Const ucIsOverwrite As Short = 7
    Public Const ucIsOverload As Short = 8
    Public Const ucIsRecursion As Short = 9
    Public Const ucIsBootstrap As Short = 10
    Public Const ucIsDelaySyntax As Short = 10
    Public Const ucIsRightToLeft As Short = 11

    Public Const ucIsArray As Short = 12

    Public Const ucIsFunction As Short = 13
    Public Const ucIsOperator As Short = 14
    Public Const ucIsInfixOp As Short = 15
    Public Const ucIsPostfixOp As Short = 16
    Public Const ucIsPrefixOp As Short = 17
    Public Const ucIsVariable As Short = 18
    Public Const ucIsJITVariable As Short = 19
    Public Const ucIsJITExpression As Short = 20
    Public Const ucIsString As Short = 21
    Public Const ucIsExternal As Short = 22
    Public Const ucIsActive As Short = 23
    Public Const ucIsItemCount As Short = 24
    Public Const ucIsSorted As Short = 25
    Public Const ucIsMaybeComplex As Short = 26
    Public Const ucIsComplexAltDef As Short = 27
    Public Const ucIsArgTypeOverload As Short = 28
    Public Const ucIsSyntax As Short = 29
    Public Const Reserved1 As Short = 30
    Public Const Reserved2 As Short = 31

    Public Const ucInfixOp As Short = ucIsInfixOp
    Public Const ucPostfixOp As Short = ucIsPostfixOp
    Public Const ucPrefixOp As Short = ucIsPrefixOp

    ' For ucElementCategory
    Public Const ucIsOperand As Short = 32
    'ucIsFunction  = (already defined)
    'ucIsInfixOp   = (already defined)
    'ucIsPrefixOp  = (already defined)
    'ucIsPostfixOp = (already defined)

    Public Const ucDataType As Short = 40
    Public Const ucResultPtr As Short = 41
    Public Const ucSignPos As Short = 42
    Public Const ucElementCat As Short = 43
    Public Const ucTreeIndex As Short = 44
    Public Const ucErrorNumber As Short = 45
    Public Const ucOpHandle As Short = 46
    Public Const ucFuncHandle As Short = ucOpHandle
    Public Const ucExprPtr As Short = 47
    Public Const ucCodeAddress As Short = 48
    Public Const ucCurrentPtr As Short = 49
    Public Const ucParentPtr As Short = 50
    Public Const ucDataHandle As Short = 51
    Public Const ucMiscData As Short = 52
    Public Const ucUserData1 As Short = 53
    Public Const ucUserData2 As Short = 54
    Public Const ucUserData3 As Short = 55
    Public Const ucUserData4 As Short = 56

    Public Const ucTreePre As Short = 5
    Public Const ucTreeDownEarly As Short = 6
    Public Const ucTreeDown As Short = 7
    Public Const ucTreeUp As Short = 8

    Public Const ucErrorCallback As Short = 9

    Public Const ucNoChange As Short = 0
    Public Const ucMinorChange As Short = 1
    Public Const ucMajorChange As Short = 2

    ' Trig mode options for ucSetTrigMode
    Public Const ucRadians As Short = 1
    Public Const ucDegrees As Short = 2
    Public Const ucGrads As Short = 3
    Public Const ucCycles As Short = 4

    ' Options for ucArrayInfo,
    ' and the first two for ucProperty.ArrayProperties
    Public Const ucArray_BoundsCheck As Short = 1
    Public Const ucArray_ColumnMajor As Short = 2
    Public Const ucArray_DataAddress As Short = 3
    Public Const ucArray_DataType As Short = 4
    Public Const ucArray_DimensionCount As Short = 5
    Public Const ucArray_ElementCount As Short = 6
    Public Const ucArray_ElementSize As Short = 7

    ' Options for fProperties parameter of ucDefineFunction
    ' and for ucProperty.FunctionProperties
    Public Const ucLeftToRight = 0
    Public Const ucInline As Short = 1
    Public Const ucDynamic As Short = 2
    Public Const ucFastCallback As Short = 4
    Public Const ucLocal As Short = 8
    Public Const ucComplex As Short = 16
    Public Const ucLocked As Short = 32
    Public Const ucConstant As Short = ucLocked
    Public Const ucOverride As Short = 64
    Public Const ucOverwrite As Short = 128
    Public Const ucOverload As Short = 256
    Public Const ucRecursion As Short = 512
    Public Const ucBootstrap As Short = 1024
    Public Const ucDelaySyntax As Short = 1024
    Public Const ucRightToLeft As Short = 2048

    ' FPU control word values for ucProperty.FPU_ControlWord,
    ' and SetFPU(), SetOrFPU, SetXorFPU, GetFPU(), RestoreFPU
    Public Const ucFPU_ErrMask_InvalidOp As Short = 1
    Public Const ucFPU_ErrMask_DenormalOp As Short = 2
    Public Const ucFPU_ErrMask_ZeroDivide As Short = 4
    Public Const ucFPU_ErrMask_Overflow As Short = 8
    Public Const ucFPU_ErrMask_Underflow As Short = 16
    Public Const ucFPU_ErrMask_PrecisionLoss As Short = 32

    Public Const ucFPU_Precision_Single As Short = 0
    Public Const ucFPU_Precision_Double As Short = 512
    Public Const ucFPU_Precision_Extended As Short = 768

    Public Const ucFPU_Round_Even As Short = 0
    Public Const ucFPU_Round_Down As Short = 1024
    Public Const ucFPU_Round_Up As Short = 2048
    Public Const ucFPU_Round_Truncate As Short = 3072

    ' For ucProperty.FPU_Turbo
    Public Const ucFPU_Safe As Integer = 0
    Public Const ucFPU_SkipSet As Integer = 1
    Public Const ucFPU_SkipReset As Integer = 65536

    ' For ucSetErrorData / ucGetErrorData
    Public Const ucNewIndex As Short = -2
    Public Const ucNewUniqueIndex As Short = -1
    Public Const ucAllErrorData As Short = -1

    ' Error Values
    Public Const ucErr_None As Short = 0
    Public Const ucErr_ucErrorData As Short = 1
    Public Const ucErr_SyntaxError As Short = 2
    Public Const ucErr_MismatchedParenth As Short = 3
    Public Const ucErr_MismatchedQuotes As Short = 4
    Public Const ucErr_UndefinedVariable As Short = 5
    Public Const ucErr_UndefinedFunction As Short = 6
    Public Const ucErr_IncorrectArgType As Short = 7
    Public Const ucErr_InvalidNumberOfArgs As Short = 8
    Public Const ucErr_InvalidOperandType As Short = 9
    Public Const ucErr_InvalidVariableName As Short = 10
    Public Const ucErr_ImplicitMult As Short = 11
    Public Const ucErr_IncompleteBlock As Short = 12

    Public Const ucErr_InvalidOperation As Short = 20
    Public Const ucErr_DenormalOperand As Short = 21
    Public Const ucErr_DivisionByZero As Short = 22
    Public Const ucErr_Overflow As Short = 23
    Public Const ucErr_Underflow As Short = 24
    Public Const ucErr_InexactResult As Short = 25
    Public Const ucErr_SubscriptOutOfRange As Short = 35
    Public Const ucErr_StackOverflow As Short = 36

    Public Const ucErr_OperationDenied As Short = 40
    Public Const ucErr_PropertyConflict As Short = 41
    Public Const ucErr_ConstantWriteDenied As Short = 42
    Public Const ucErr_FunctionDefError As Short = 43
    Public Const ucErr_FunctionLocked As Short = 44

    Public Const ucErr_DefinitionSpaceFull As Short = 60
    Public Const ucErr_ThreadInitFailed As Short = 61
    Public Const ucErr_UnsupportedFeature As Short = 62

    Public Const Op_Func_GetFPU As Short = 36
    Public Const Op_Func_SetFPU As Short = 37
    Public Const Op_Func_SetOrFPU As Short = 38
    Public Const Op_Func_SetXorFPU As Short = 39
    Public Const Op_Func_RestoreFPU As Short = 40
    Public Const Op_Func_Ceil As Short = 41
    Public Const Op_Func_Factorial As Short = 42
    Public Const Op_Func_Not As Short = 43
    Public Const Op_Cur_Add As Short = 44
    Public Const Op_Cur_Multiply As Short = 45
    Public Const Op_Cur_Subtract As Short = 46
    Public Const Op_Cur_DivideToExt As Short = 47
    Public Const Op_Qwd_Add As Short = 48
    Public Const Op_Qwd_Multiply As Short = 49
    Public Const Op_Qwd_Subtract As Short = 50
    Public Const Op_Qwd_DivideToInt As Short = 51
    Public Const Op_Qwd_DivideToExt As Short = 52
    Public Const Op_Int_Add As Short = 53
    Public Const Op_Int_Multiply As Short = 54
    Public Const Op_Int_Subtract As Short = 55
    Public Const Op_Int_DivideToInt As Short = 56
    Public Const Op_Int_DivideToExt As Short = 57
    Public Const Op_Int_Mod As Short = 58
    Public Const Op_IntPower As Short = 59

    Public ucInitialized As Integer
    Public t0 As ucThreadType

    Public Delegate Function ucCallbackDbl(ByRef t As ucThreadType) As Double
    Public Delegate Function ucCallbackInt(ByRef t As ucThreadType) As Integer

    Public Declare Sub ucDetachSymbolE Lib "ucalcfmp.dll" (ByVal Symbol As String, ByVal t As Integer)
    Public Declare Sub ucErrorClearE Lib "ucalcfmp.dll" (ByVal t As Integer)
    Public Declare Sub ucLicenseE Lib "ucalcfmp.dll" (ByVal SerialNumber As String)
    Public Declare Sub ucReleaseItemE Lib "ucalcfmp.dll" (ByVal ItemHandle As Integer)
    Public Declare Sub ucReleaseThreadE Lib "ucalcfmp.dll" (ByVal ucThread As Integer)
    Public Declare Sub ucResetE Lib "ucalcfmp.dll" (ByVal t As Integer)
    Public Declare Sub ucReturnDblE Lib "ucalcfmp.dll" (ByVal vValue As Double, ByRef t As ucThreadType)
    Public Declare Sub ucReturnCplxDblE Lib "ucalcfmp.dll" (ByVal vValue As Double, ByRef t As ucThreadType)
    Public Declare Sub ucReturnStrE Lib "ucalcfmp.dll" (ByVal Expression As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetErrorDataE Lib "ucalcfmp.dll" (ByVal errIndex As Integer, ByVal vValue As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetParamStrE Lib "ucalcfmp.dll" (ByVal ParamIndex As Integer, ByVal Argument As String, ByRef t As ucThreadType)
    Public Declare Sub ucSetThreadDataE Lib "ucalcfmp.dll" (ByVal ucThread As Integer, ByRef t As ucThreadType)
    Public Declare Sub ucSetTrigModeE Lib "ucalcfmp.dll" (ByVal TrigMode As Integer, ByVal t As Integer)
    Public Declare Sub ucSetVariableValueDblE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal vValue As Double)
    Public Declare Sub ucSetVariableValueStrE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal vValue As String)
    Public Declare Sub ucTreeSetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByVal pData As String, ByRef t As ucThreadType)
    Public Declare Function ucAliasE Lib "ucalcfmp.dll" (ByVal AssignFrom As String, ByVal AssignTo As String, ByVal aProperties As Integer, ByVal Precedence As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucArrayInfoE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal InfoOption As Integer) As Integer
    Public Declare Function ucDefineE Lib "ucalcfmp.dll" (ByVal Definition As String, ByVal t As Integer) As Integer
    Public Declare Function ucDefineFunctionE Lib "ucalcfmp.dll" (ByVal FunctionDef As String, ByVal FunctionAddress As ucCallbackDbl, ByVal Precedence As Integer, ByVal fProperties As Integer, ByVal vType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucDefineFuncE Lib "ucalcfmp.dll" Alias "ucDefineFunctionE" (ByVal FunctionDef As String, ByVal FunctionAddress As Integer, ByVal Precedence As Integer, ByVal fProperties As Integer, ByVal vType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucDefineVariableE Lib "ucalcfmp.dll" (ByVal VariableDef As String, ByVal vPtr As Integer, ByVal Expr As Integer, ByVal vProperties As Integer, ByVal vType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucEvalE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal t As Integer) As Double
    Public Declare Function ucEvalStrE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal t As Integer) As String
    Public Declare Function ucEvaluateStrE Lib "ucalcfmp.dll" (ByVal ExpressionPtr As Integer) As String
    Public Declare Function ucGetErrorDataE Lib "ucalcfmp.dll" (ByVal errIndex As Integer, ByVal t As Integer) As String
    Public Declare Function ucGetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Double
    Public Declare Function ucGetParamCplxE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Double
    Public Declare Function ucGetParamStrE Lib "ucalcfmp.dll" (ByVal ParamIndex As Integer, ByRef t As ucThreadType) As String
    Public Declare Function ucGetThreadInfoE Lib "ucalcfmp.dll" (ByVal ucThread As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucGetVariableValueE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer) As Double
    Public Declare Function ucGetVariableValueStrE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer) As String
    Public Declare Function ucImagPartE Lib "ucalcfmp.dll" (ByVal t As Integer) As Double
    Public Declare Function ucLowerBoundE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal Dimension As Integer) As Integer
    Public Declare Function ucNewThreadE Lib "ucalcfmp.dll" () As Integer
    Public Declare Function ucNewSymbolHandleE Lib "ucalcfmp.dll" (ByVal t As Integer) As Integer
    Public Declare Function ucOpE Lib "ucalcfmp.dll" (ByVal OpID As Integer) As Integer
    Public Declare Function ucParamHandleE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucParamTypeE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucParseE Lib "ucalcfmp.dll" (ByVal Expression As String, ByVal LocalVars As String, ByVal ExprType As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucPrecedenceE Lib "ucalcfmp.dll" (ByVal Op As String, ByVal OpCategory As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucSetCallbackE Lib "ucalcfmp.dll" (ByVal FunctionAddress As ucCallbackInt, ByVal TreeOption As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucSymbolHandleE Lib "ucalcfmp.dll" (ByVal ucSymbol As String, ByVal SymbolProperty As Integer, ByVal t As Integer) As Integer
    Public Declare Function ucThreadAddrE Lib "ucalcfmp.dll" (ByVal t As Integer) As Integer
    Public Declare Function ucTreeGetParamE Lib "ucalcfmp.dll" (ByVal pIndex As Integer, ByRef t As ucThreadType) As String
    Public Declare Function ucTreePropertyE Lib "ucalcfmp.dll" (ByVal NodePtr As Integer, ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
    Public Declare Function ucUpperBoundE Lib "ucalcfmp.dll" (ByVal VarHandle As Integer, ByVal Dimension As Integer) As Integer

    ' These 3 functions come from ucalcfmE.dll instead of ucalcfmP.dll
    Public Declare Function ucEvaluate Lib "ucalcfme.dll" Alias "ucEvaluateE" (ByVal ExpressionPtr As Integer) As Double
    Public Declare Function ucEvaluateLng Lib "ucalcfme.dll" Alias "ucEvaluateLngE" (ByVal ExpressionPtr As Integer) As Integer
    Public Declare Function ucEvaluateQwd Lib "ucalcfme.dll" Alias "ucEvaluateQwdE" (ByVal ExpressionPtr As Integer) As Long

    Public Declare Sub ucEvaluateInitE Lib "ucalcfme.dll" ()
    Public Declare Sub ucReleaseExprPtrE Lib "ucalcfme.dll" (ByVal ExpressionPtr As Integer)


    Public Function ucPrecedence(ByRef Op As String, Optional ByVal OpCategory As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucPrecedence = ucPrecedenceE(Op, OpCategory, ucThreadAddr(t))
    End Function

    Public Function ucSymbolHandle(ByRef ucSymbolE As String, Optional ByVal SymbolProperty As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucSymbolHandle = ucSymbolHandleE(ucSymbolE, SymbolProperty, ucThreadAddr(t))
    End Function

    Public Function ucError() As Integer
        ucGetThreadInfo(0, t0)
        ucError = t0.ErrorNumber
    End Function

    Public ReadOnly Property ucErrorData(ByVal errIndex As Integer, Optional ByVal t As Integer = 0) As String
        Get
            ucErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
        End Get
    End Property

    Public ReadOnly Property ucGetErrorData(ByVal errIndex As Integer, Optional ByVal t As Integer = 0) As String
        Get
            ucGetErrorData = ucGetErrorDataE(errIndex, ucThreadAddr(t))
        End Get
    End Property


    Public Property ucVariableValue(ByVal VarHandle As Integer) As Double
        Get
            ucVariableValue = ucGetVariableValueE(VarHandle)
        End Get
        Set(ByVal Value As Double)
            ucSetVariableValueDblE(VarHandle, Value)
        End Set
    End Property


    Public Property ucVariableValueStr(ByVal VarHandle As Integer) As String
        Get
            ucVariableValueStr = ucGetVariableValueStrE(VarHandle)
        End Get
        Set(ByVal Value As String)
            ucSetVariableValueStrE(VarHandle, Value)
        End Set
    End Property

    Public Property ucParamStr(ByVal ParamIndex As Integer, ByVal t As ucThreadType) As String
        Get
            ucParamStr = ucGetParamStrE(ParamIndex, t)
        End Get
        Set(ByVal Value As String)
            ucSetParamStrE(ParamIndex, Value, t)
        End Set
    End Property

    Public Function ucAttachVariable(ByRef VariableDef As String, ByRef vPtr As Integer, Optional ByVal ExprPtr As Integer = 0, Optional ByVal vProperties As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucAttachVariable = ucDefineVariableE(VariableDef, vPtr, ExprPtr, vProperties, t0.ucProperty.DefaultNumericType, ucThreadAddr(t))
    End Function

    Public Function ucDefine(ByRef Definition As String) As Integer
        ucDefine = ucDefineE(Definition, ucThreadAddr(0))
    End Function

    Public Function ucDefineFunc(ByRef FunctionDef As String, Optional ByVal FunctionAddress As Integer = 0, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineFunc = ucDefineFuncE(FunctionDef, FunctionAddress, 0, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucDefineFunction(ByRef FunctionDef As String, Optional ByVal FunctionAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineFunction = ucDefineFunctionE(FunctionDef, FunctionAddress, 0, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucDefineMacro(ByRef Definition As String) As Integer
        ucDefineMacro = ucDefineE("Macro " + Definition, ucThreadAddr(0))
    End Function

    Public Function ucDefineOp(ByRef OperatorDef As String, Optional ByVal Precedence As Integer = 0, Optional ByVal OperatorAddress As Integer = 0, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineOp = ucDefineFuncE(OperatorDef, OperatorAddress, Precedence, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucDefineOperator(ByRef OperatorDef As String, Optional ByVal Precedence As Integer = 0, Optional ByVal OperatorAddress As ucCallbackDbl = Nothing, Optional ByVal fProperties As Integer = 0, Optional ByVal vType As Integer = 0) As Integer
        ucDefineOperator = ucDefineFunctionE(OperatorDef, OperatorAddress, Precedence, fProperties, vType, ucThreadAddr(0))
    End Function

    Public Function ucDefineSyntax(ByRef Definition As String) As Integer
        ucDefineSyntax = ucDefineE("Syntax " + Definition, ucThreadAddr(0))
    End Function

    Public Function ucAlias(ByRef AssignFrom As String, ByRef AssignTo As String, Optional ByVal aProperties As Integer = 0, Optional ByVal Precedence As Integer = 0) As Integer
        ucAlias = ucAliasE(AssignFrom, AssignTo, aProperties, Precedence, ucThreadAddr(0))
    End Function

    Public Sub ucDetachSymbol(ByRef Symbol As String, ByVal t As Integer)
        ucDetachSymbolE(Symbol, ucThreadAddr(t))
    End Sub

    Public Sub ucErrorClear()
        ucErrorClearE(ucThreadAddr(0))
    End Sub

    Public Function ucDefineConstant(ByRef ConstantDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineConstant = ucDefineVariableE(ConstantDef, 0, 0, vProperties + ucConstant, t0.ucProperty.DefaultNumericType, ucThreadAddr(0))
    End Function

    Public Sub ucReset()
        Dim Between_Mult_Pow As Integer
        Dim Between_And_Less As Integer
        Dim Between_Div_Mod As Integer

        ' +++ Need ucItem equivalent for VB.NET

        ucEvaluateInitE()
        ucGetThreadInfo(0, t0)
        ucResetE(ucThreadAddr(0))
        ucGetThreadInfo(0, t0)

        t0.Context = t0.Context Or ucContext_ucReset
        t0.Handshake.LanguageID = uc_Lang_VisualBasicNET
        t0.ucProperty.ComplexNumbers = ucTrue
        t0.ucProperty.EscapeChar = Asc("~")
        t0.ucProperty.DefaultExternalStringType = ucType_StringBSTR

        ucDefineConstant("Byte     = uc_Integer8u")
        ucDefineConstant("Integer  = uc_Integer16")
        ucDefineConstant("Word     = uc_Integer16u")
        ucDefineConstant("Long     = uc_Integer32")
        ucDefineConstant("DWord    = uc_Integer32u")
        ucDefineConstant("Quad     = uc_Integer64")
        ucDefineConstant("Currency = uc_Currency")
        ucDefineConstant("CurrencyX= uc_CurrencyExt")
        ucDefineConstant("Single   = uc_FloatSingle")
        ucDefineConstant("Double   = uc_FloatDouble")
        ucDefineConstant("Extended = uc_FloatExtended")
        ucDefineConstant("AsciiZ   = uc_StringLPSTR")
        ucDefineConstant("String   = uc_StringAnsi")
        ucDefineConstant("FixedPt  = Currency")
        ucDefineConstant("Any      = uc_Any")

        Between_Mult_Pow = (ucPrecedence("*") + ucPrecedence("^")) / 2
        Between_And_Less = (ucPrecedence("AND") + ucPrecedence("<")) / 2
        Between_Div_Mod = (ucPrecedence("/") + ucPrecedence("MOD")) / 2

        t0.ucProperty.FunctionProperties = ucFastCallback + ucOverload

        ucDefineOp("*[x As Long, y As Long] As Long", ucPrecedence("*"), ucOp(Op_Int_Multiply))
        ucDefineOp("-[x As Long, y As Long] As Long", ucPrecedence("-"), ucOp(Op_Int_Subtract))
        ucDefineOp("+[x As Long, y As Long] As Long", ucPrecedence("+"), ucOp(Op_Int_Add))
        ucDefineOp("/[x As Long, y As Long] As Extended", ucPrecedence("/"), ucOp(Op_Int_DivideToExt))
        ucDefineOp("\[x As Long, y As Long] As Long", Between_Div_Mod, ucOp(Op_Int_DivideToInt))
        ucDefineOp("Mod[x As Long, y As Long] As Long", ucPrecedence("MOD"), ucOp(Op_Int_Mod))
        ucDefineOp("^[x As Extended, y As Long] As Extended", ucPrecedence("^"), ucOp(Op_IntPower))

        ucDefineOp("*[x As Quad, y As Quad] As Quad", ucPrecedence("*"), ucOp(Op_Qwd_Multiply))
        ucDefineOp("-[x As Quad, y As Quad] As Quad", ucPrecedence("-"), ucOp(Op_Qwd_Subtract))
        ucDefineOp("+[x As Quad, y As Quad] As Quad", ucPrecedence("+"), ucOp(Op_Qwd_Add))
        ucDefineOp("/[x As Quad, y As Quad] As Extended", ucPrecedence("/"), ucOp(Op_Qwd_DivideToExt))
        ucDefineOp("\[x As Quad, y As Quad] As Quad", Between_Div_Mod, ucOp(Op_Qwd_DivideToInt))

        ucDefineOp("*[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("*"), ucOp(Op_Cur_Multiply))
        ucDefineOp("-[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("-"), ucOp(Op_Cur_Subtract))
        ucDefineOp("+[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("+"), ucOp(Op_Cur_Add))
        ucDefineOp("/[x As FixedPt, y As FixedPt] As Extended", ucPrecedence("/"), ucOp(Op_Cur_DivideToExt))

        ucDefineFunc("Fact(x As Long)", ucOp(Op_Func_Factorial))
        ucDefineFunc("GetFPU(x As Long) As Long", ucOp(Op_Func_GetFPU))
        ucDefineFunc("SetFPU(x As Long)", ucOp(Op_Func_SetFPU))
        ucDefineFunc("SetOrFPU(x As Long)", ucOp(Op_Func_SetOrFPU))
        ucDefineFunc("SetXorFPU(x As Long)", ucOp(Op_Func_SetXorFPU))
        ucDefineFunc("RestoreFPU(x As Long)", ucOp(Op_Func_RestoreFPU))
        ucDefineFunc("Ceil(x)", ucOp(Op_Func_Ceil))
        ucDefineFunc("Not(x)", ucOp(Op_Func_Not))

        ' String relational (comparison) operators
        t0.ucProperty.DefaultPrecedence = ucPrecedence("<")
        t0.ucProperty.FunctionProperties = ucDynamic + ucLocked + ucOverride + ucOverload
        ucDefineFunction("StrCmp(a As String, b As String) = StrCmp(0, 0, a, b)")
        ucDefineOperator(" =[a As String, b As String] = StrCmp(a, b) = 2")
        ucDefineOperator("<>[a As String, b As String] = StrCmp(a, b) <> 2")
        ucDefineOperator(" >[a As String, b As String] = StrCmp(a, b) = 3")
        ucDefineOperator(">=[a As String, b As String] = StrCmp(a, b) > 1")
        ucDefineOperator(" <[a As String, b As String] = StrCmp(a, b) = 1")
        ucDefineOperator("<=[a As String, b As String] = StrCmp(a, b) < 3")

        Static d_ucPrecedence As ucCallbackDbl = New ucCallbackDbl(AddressOf uc_Precedence)
        Static d_ucPrecedenceMax As ucCallbackDbl = New ucCallbackDbl(AddressOf uc_PrecedenceMax)
        Static d_ucPrecedenceMin As ucCallbackDbl = New ucCallbackDbl(AddressOf uc_PrecedenceMin)

        t0.ucProperty.FunctionProperties = ucInline + ucLocked + ucOverride + ucOverload

        ucDefineFunction("Precedence(Operator$, OpCategory = 0)", d_ucPrecedence)
        ucDefineFunction("PrecedenceMax()", d_ucPrecedenceMax)
        ucDefineFunction("PrecedenceMin()", d_ucPrecedenceMin)

        ucDefineMacro(".[x]  ::= (0.x) ::: Precedence = PrecedenceMax")
        ucDefineMacro(" [x]. ::= (x.0) ::: Precedence = PrecedenceMax")

        ' Hex, binary, octal notations.  Includes support for non-integers
        ucDefineSyntax("#b (Number:'[0-1]+') [(Frac:'\.[0-1]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 2) ::: Precedence = PrecedenceMax")
        ucDefineSyntax("#o (Number:'[0-7]+') [(Frac:'\.[0-7]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 8) ::: Precedence = PrecedenceMax")
        ucDefineSyntax("#h (Number:'[0-9A-F]+') [(Frac:'\.[0-9A-F]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 16) ::: Precedence = PrecedenceMax")
        ucDefineSyntax("#i ::= ~i")

        ' Alternative notations
        '   ucDefineOperator "  &[a,b] = a and b", ucPrecedence("and")
        '   ucDefineOperator "  |[a,b] = a or  b", ucPrecedence("or ")
        '   ucDefineOperator " =<[a,b] = a <=  b", ucPrecedence("<= ")
        '   ucDefineOperator " =>[a,b] = a >=  b", ucPrecedence(">= ")
        ucDefineOperator(" ==[a,b] = a  =  b", ucPrecedence("="))
        ucDefineOperator("DIV[a,b] = a  \  b", ucPrecedence("\"))
        ucDefineOperator("**[a,b]  = a  ^  b", ucPrecedence("^"))
        ucDefineMacro(" &[TextA,TextB] = TextA + TextB")
        ucDefineOperator("==[TextA$,TextB$] = TextA = TextB", ucPrecedence("="))
        ucDefineOperator("Imp[a, b] = (Not(a)) Or b", ucPrecedence("OR")-1)
        ucDefineOperator("Eqv[a, b] = (a and b) Or (not(a) and not(b))", ucPrecedence("OR")-1)
        ucDefineFunction("Concatenate$(a$,b$) = a + b")
        ucDefineFunction("Sign(x) = Sgn(x)")
        ucDefineFunction("Sqrt(x) = Sqr(x)")
        ucDefineFunction("Ln(x)   = Log(x)")
        ucDefineFunction("Atan(x) = Atn(x)")
        ucDefineOperator("[x]! = fact(x)", t0.PrecedenceMax)
        ucDefineOperator("[x]% = x/100", t0.PrecedenceMax)
        ucDefineOperator("%[x,y] = x mod y", ucPrecedence("MOD"))
        ucDefineOperator("-[x] = 0-x", Between_Mult_Pow)
        ucDefineOperator("+[x] = 0+x", Between_Mult_Pow)
        ucDefineOperator("Not[x] = Not(x)", Between_And_Less)

        ' FPU routines
        ucDefineFunction("GetFPU() = GetFPU(0)")
        ucDefineFunction("RestoreFPU() = RestoreFPU(0)")
        ucAlias("GetFPU", "GetFPU(0)")
        ucAlias("RestoreFPU", "RestoreFPU(0)")
        ucAlias("SetFPU(setting, Expression)", "(SetFPU(setting)+(Expression)+RestoreFPU(0))")
        ucAlias("SetOrFPU(setting, Expression)", "(SetOrFPU(setting)+(Expression)+RestoreFPU(0))")
        ucAlias("SetXorFPU(setting, Expression)", "(SetXorFPU(setting)+(Expression)+RestoreFPU(0))")

        ucDefineFunction("Inf() = SetOrFPU(4, 1/0)", Nothing, ucDynamic)
        ucDefineFunction("NaN() = SetOrFPU(1, 0/0)", Nothing, ucDynamic)

        ' Hyperbolic functions
        ucDefineFunction("Sinh(x)  = (exp(x) - exp(-x)) / 2")
        ucDefineFunction("Cosh(x)  = (exp(x) + exp(-x)) / 2")
        ucDefineFunction("Tanh(x)  = (exp(2x) - 1) / (exp(2x) + 1)")
        ucDefineFunction("Coth(x)  = (exp(2x) + 1) / (exp(2x) - 1)")
        ucDefineFunction("Sech(x)  = 2 / (exp(x) + exp(-x))")
        ucDefineFunction("Csch(x)  = 2 / (exp(x) - exp(-x))")
        ucDefineFunction("Asinh(x) = Log(x + Sqr(x ^ 2 + 1))")
        ucDefineFunction("Acosh(x) = Log(x + Sqr(x ^ 2 - 1))")
        ucDefineFunction("Atanh(x) = Log((1 + x) / (1 - x)) / 2")
        ucDefineFunction("Acoth(x) = Log((x + 1) / (x - 1)) / 2")
        ucDefineFunction("Asech(x) = Log((1 + Sqr(1 - x ^ 2)) / x)")
        ucDefineFunction("Acsch(x) = Log(1 / x + Sqr(1 + x ^ 2) / Abs(x))")

        ' A few constants needed in some definitions further down
        ucDefineConstant("Pi     = Atn(1) * 4")
        ucDefineConstant("HalfPI = Pi/2")

        ' Other functions
        ucDefineFunction("Sec(x)   = 1 / Cos(x)")
        ucDefineFunction("Csc(x)   = 1 / Sin(x)")
        ucDefineFunction("Cot(x)   = 1 / Tan(x)")
        ucDefineFunction("Asin(x)  = SetOrFPU(4, Atn(x / Sqr(1 - x * x)))") ' +++ make provisions for complex
        ucDefineFunction("Acos(x)  = HalfPI - Asin(x)")
        ucDefineFunction("Log2(x)  = Log(x) / Log(2)")
        ucDefineFunction("Exp2(x)  = 2 ^ x")
        ucDefineFunction("Log10(x) = Log(x) / Log(10)")
        ucDefineFunction("Exp10(x) = 10 ^ x")

        ' Complex operators & functions
        t0.ucProperty.FunctionProperties = ucDynamic + ucLocked + ucOverride + ucOverload + ucComplex
        ucDefineOperator("+[x] = x.Real + x.Imag*#i", Between_Mult_Pow)
        ucDefineOperator("-[x] = (-x.Real) + (-x.Imag)*#i", Between_Mult_Pow)

        ucDefineOperator("+[x,y] = x.Real+y.Real + (x.Imag+y.Imag)*#i", ucPrecedence("+"))
        ucDefineOperator("*[x,y] = (x.Real*y.Real - x.Imag*y.Imag)+(x.Real*y.Imag + x.Imag*y.Real)*#i", ucPrecedence("*"))
        ucDefineOperator("-[x,y] = (x.Real-y.Real) + (x.Imag-y.Imag)*#i", ucPrecedence("-"))
        ucDefineOperator("/[x,y] = x.Real*y.Real/(y.Real^2+y.Imag^2) + x.Imag*y.Imag" & "/(y.Real^2+y.Imag^2) + (x.Imag*y.Real/(y.Real^2+y.Imag^2)-x.Real*y.Imag" & "/(y.Real^2+y.Imag^2))*#i", ucPrecedence("/"))

        ucDefineFunction("Abs(x) = Sqr(x.Real^2 + x.Imag^2) + 0*#i")
        ucDefineFunction("Sgn(x) = x.Real/Abs(x) + x.Imag/Abs(x)*#i")
        ucDefineFunction("Sin(x) = Sin(x.Real)*Cosh(x.Imag) + Cos(x.Real)*Sinh(x.Imag)*#i")
        ucDefineFunction("Cos(x) = Cos(x.Real)*Cosh(x.Imag) - Sin(x.Real)*Sinh(x.Imag)*#i")
        ucDefineFunction("Phase(x) = iif(x.Imag=0, iif(x.Real>0, 0, pi), atn(x.Imag/x.Real)) + 0*#i")
        ucDefineFunction("Conj(x)  = x.Real - x.Imag*#i")
        ucDefineFunction("Exp(x)   = exp(x.Real)*Cos(x.Imag) + exp(x.Real)*sin(x.Imag)*#i")
        ucDefineFunction("Imag(x)  = x.Imag + 0*#i")
        ucDefineFunction("Real(x)  = x.Real + 0*#i")

        ucDefineFunction("Sqr(x)   = Sqr(Sqr(x.Real^2 + x.Imag^2)+x.Real)/Sqr(2)" & "+ (Sqr(Sqr(x.Real^2 + x.Imag^2)-x.Real)*iif(x.Imag < 0, -1, 1)/Sqr(2))*#i")
        ucDefineFunction("Sqrt(x)  = Sqr(x.Real+x.Imag*#i)")

        ucDefineFunction("Log(x) = iif(x.Real=0 and x.Imag=0, -Inf," & "Log(x.Real^2 + x.Imag^2)/2)" & "+iif(x.Real=0 and x.Imag=0, 0, iif(x.Real>0 and x.Imag=0, 0," & "iif(x.Imag=0, pi, pi*sgn(x.Imag)/2-Atn(x.Real/x.Imag))))*#i")

        ucDefineFunction("_ZeroToZero() = 1", Nothing, ucDynamic + ucOverwrite)
        '  ucDefineFunction "_ZeroToZero() = 0", 0, ucDynamic+ucOverwrite
        '  ucDefineFunction "_ZeroToZero() = NaN", 0, ucDynamic+ucOverwrite
        '  ucDefineFunction "_ZeroToZero() = SetError(1, '0^0 Error')", 0, ucDynamic+ucOverwrite

        ucDefineOperator("^[x,y] = iif(x.Imag = 0, iif(x.Real > 0," & "x.Real^y.Real*Cos(y.Imag*Log(x.Real))," & "iif(x.Real=0 and y.Real=0 and y.Imag=0, _ZeroToZero()," & "(-x.Real)^y.Real*COS(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag)))," & "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)" & "*COS(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag" & "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag))))-55+55" & "+iif(x.Imag = 0, iif(x.Real > 0," & "x.Real^y.Real*SIN(y.Imag*LOG(x.Real))," & "iif(x.Real=0 and y.Real=0 and y.Imag=0, 0," & "(-x.Real)^y.Real*SIN(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag)))," & "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)" & "*SIN(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag" & "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag)))-55+55)*#i", ucPrecedence("^"))

        t0.ucProperty.FunctionProperties = ucDynamic + ucOverload + ucOverwrite + ucComplex + ucRecursion
        t0.ucProperty.DefaultNumericType = ucType_Double
        t0.Context = t0.Context Xor ucContext_ucReset
        t0.ucProperty.DefaultPrecedence = Between_Div_Mod ' arbitrarily chosen
    End Sub

    Public Function ucGetThreadInfo(ByVal ucThread As Integer, ByRef t As ucThreadType) As Integer
        ucGetThreadInfo = ucGetThreadInfoE(ucThread, t)
    End Function

    Public Sub ucSetThreadData(ByVal ucThread As Integer, ByRef t As ucThreadType)
        If ucInitialized Then ucSetThreadDataE(ucThread, t)
    End Sub

    Public Sub ucSetTrigMode(ByVal TrigMode As Integer, Optional ByVal t As Integer = 0)
        ucSetTrigModeE(TrigMode, ucThreadAddr(t))
    End Sub

    Public Function ucArrayInfo(ByVal VarHandle As Integer, ByVal InfoOption As Integer) As Integer
        ucArrayInfo = ucArrayInfoE(VarHandle, InfoOption)
    End Function

    Public Function ucLowerBound(ByVal VarHandle As Integer, Optional ByVal Dimension As Integer = 1) As Integer
        ucLowerBound = ucLowerBoundE(VarHandle, Dimension)
    End Function

    Public Function ucParse(ByRef Expression As String, Optional ByRef LocalVars As String = "", Optional ByRef ExprType As Integer = 0) As Integer
        ucParse = ucParseE(Expression, LocalVars, ExprType, ucThreadAddr(0))
    End Function

    Public Function ucUpperBound(ByVal VarHandle As Integer, Optional ByVal Dimension As Integer = 1) As Integer
        ucUpperBound = ucUpperBoundE(VarHandle, Dimension)
    End Function

    Public Function ucNewSymbolHandle(Optional ByVal t As Integer = 0) As Integer
        ucNewSymbolHandle = ucNewSymbolHandleE(ucThreadAddr(t))
    End Function

    Public Sub ucReturn(ByVal vValue As Double, ByRef t As ucThreadType)
        ucReturnDblE(vValue, t)
    End Sub

    Public Sub ucReturnCplx(ByVal vValue As Double, ByRef t As ucThreadType)
        ucReturnCplxDblE(vValue, t)
    End Sub

    Public Sub ucReturnStr(ByRef Expression As String, ByRef t As ucThreadType)
        ucReturnStrE(Expression, t)
    End Sub

    Public Function ucErrorHandler(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucErrorHandler = ucSetCallbackE(FunctionAddress, ucErrorCallback, ucThreadAddr(0))
    End Function

    Public Function ucEval(ByRef Expression As String, Optional ByVal t As Integer = 0) As Double
        ucEval = ucEvalE(Expression, ucThreadAddr(t))
    End Function

    Public Function ucEvalStr(ByRef Expression As String, Optional ByVal t As Integer = 0) As String
        ucEvalStr = ucEvalStrE(Expression, ucThreadAddr(t))
    End Function

    Public Function ucEvaluateStr(ByVal ExpressionPtr As Integer) As String
        ucEvaluateStr = ucEvaluateStrE(ExpressionPtr)
    End Function

    Public Function ucGetVariableValue(ByVal VarHandle As Integer) As Double
        ucGetVariableValue = ucGetVariableValueE(VarHandle)
    End Function

    Public Function ucGetVariableValueStr(ByVal VarHandle As Integer) As String
        ucGetVariableValueStr = ucGetVariableValueStrE(VarHandle)
    End Function

    Public Sub ucSetVariableValue(ByVal VarHandle As Integer, ByVal vValue As Double)
        ucSetVariableValueDblE(VarHandle, vValue)
    End Sub

    Public Sub ucSetVariableValueStr(ByVal VarHandle As Integer, ByRef vValue As String)
        ucSetVariableValueStrE(VarHandle, vValue & Chr(0))
    End Sub

    Public Function ucImagPart(Optional ByVal t As Integer = 0) As Double
        ucImagPart = ucImagPartE(ucThreadAddr(t))
    End Function

    Public Function ucPreParse(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucPreParse = ucSetCallbackE(FunctionAddress, ucTreePre, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseDownEarly(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDownEarly = ucSetCallbackE(FunctionAddress, ucTreeDownEarly, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseDown(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseDown = ucSetCallbackE(FunctionAddress, ucTreeDown, ucThreadAddr(0))
    End Function

    Public Function ucTreeParseUp(ByVal FunctionAddress As ucCallbackInt) As Integer
        ucTreeParseUp = ucSetCallbackE(FunctionAddress, ucTreeUp, ucThreadAddr(0))
    End Function

    Public Function ucGetExpr(ByRef t As ucThreadType) As String
        ucGetExpr = ucTreeGetParamE(-1, t)
    End Function

    Public Function ucTreeGetExpr(ByRef t As ucThreadType) As String
        ucTreeGetExpr = ucTreeGetParamE(-1, t)
    End Function

    Public Function ucTreeGetFunc(ByRef t As ucThreadType) As String
        ucTreeGetFunc = ucTreeGetParamE(0, t)
    End Function

    Public Function ucTreeGetOp(ByRef t As ucThreadType) As String
        ucTreeGetOp = ucTreeGetParamE(0, t)
    End Function

    Public Function ucTreeGetParam(ByVal pIndex As Integer, ByRef t As ucThreadType) As String
        ucTreeGetParam = ucTreeGetParamE(pIndex, t)
    End Function

    Public Function ucTreeGetParamList(ByRef t As ucThreadType) As String
        ucTreeGetParamList = ucTreeGetParamE(-2, t)
    End Function

    Public Sub ucSetExpr(ByRef Expression As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-1, Expression, t)
    End Sub

    Public Sub ucTreeSetExpr(ByRef Expression As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-1, Expression, t)
    End Sub

    Public Sub ucTreeSetFunc(ByRef TreeFunc As String, ByRef t As ucThreadType)
        ucTreeSetParamE(0, TreeFunc, t)
    End Sub

    Public Sub ucTreeSetOp(ByRef TreeOp As String, ByRef t As ucThreadType)
        ucTreeSetParamE(0, TreeOp, t)
    End Sub

    Public Sub ucTreeSetParam(ByVal pIndex As Integer, ByRef pData As String, ByRef t As ucThreadType)
        ucTreeSetParamE(pIndex, pData, t)
    End Sub

    Public Sub ucTreeSetParamList(ByRef pData As String, ByRef t As ucThreadType)
        ucTreeSetParamE(-2, pData, t)
    End Sub

    Public Function ucElementCategory(ByRef t As ucThreadType) As Integer
        ucElementCategory = ucTreePropertyE(0, 0, ucElementCat, t)
    End Function

    Public Function ucTreeProperty(ByVal NodePtr As Integer, ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeProperty = ucTreePropertyE(NodePtr, pIndex, pOption, t)
    End Function

    Public Function ucTreeNodeProperty(ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeNodeProperty = ucTreePropertyE(0, 0, pOption, t)
    End Function

    Public Function ucTreeParamProperty(ByVal pIndex As Integer, ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        ucTreeParamProperty = ucTreePropertyE(0, pIndex, pOption, t)
    End Function

    Public Function ucTreeParentProperty(ByVal pOption As Integer, ByRef t As ucThreadType) As Integer
        Dim ParentPtr As Integer

        ParentPtr = ucTreePropertyE(0, 0, ucParentPtr, t)
        ucTreeParentProperty = ucTreePropertyE(ParentPtr, 0, pOption, t)
    End Function

    Public Function ucDefineVariable(ByRef VariableDef As String, Optional ByVal vProperties As Integer = 0) As Integer
        ucDefineVariable = ucDefineVariableE(VariableDef, 0, 0, vProperties, t0.ucProperty.DefaultNumericType, ucThreadAddr(0))
    End Function

    Public Function ucGetParamStr(ByVal ParamIndex As Integer, ByRef t As ucThreadType) As String
        ucGetParamStr = ucGetParamStrE(ParamIndex, t)
    End Function
    Public Sub ucSetParamStr(ByVal ParamIndex As Integer, ByRef Argument As String, ByRef t As ucThreadType)
        ucSetParamStrE(ParamIndex, Argument, t)
    End Sub

    Public Sub ucReleaseExprPtr(ByVal ExpressionPtr As Integer)
        ucReleaseExprPtrE(ExpressionPtr)
    End Sub

    Public Sub ucReleaseItem(ByVal ItemHandle As Integer)
        ucReleaseItemE(ItemHandle)
    End Sub

    'Public Property Let ucErrorData(ByVal errIndex As Long, t As ucThreadType, vValue As String)
    '   ucSetErrorDataE errIndex, vValue, t
    'End Property ' +++

    Public Sub ucLicense(ByRef SerialNumber As String)
        ucLicenseE(SerialNumber)
    End Sub

    Public Function ucOp(ByVal OpID As Integer) As Integer
        ucOp = ucOpE(OpID)
    End Function

    Public Function ucParam(ByVal x As Integer, ByRef t As ucThreadType) As Double
        ucParam = ucGetParamE(x, t)
    End Function

    Public Function ucParamCplx(ByVal x As Integer, ByRef t As ucThreadType) As Double
        ucParamCplx = ucGetParamCplxE(x, t)
    End Function

    Public Function ucParamHandle(ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
        ucParamHandle = ucParamHandleE(pIndex, t)
    End Function

    Public Function ucParamType(ByVal pIndex As Integer, ByRef t As ucThreadType) As Integer
        ucParamType = ucParamTypeE(pIndex, t)
    End Function

    Public Sub ucSetErrorData(ByVal errIndex As Integer, ByRef vValue As String, ByRef t As ucThreadType)
        ucSetErrorDataE(errIndex, vValue, t)
    End Sub

    Private Function uc_Precedence(ByRef t As ucThreadType) As Double
        uc_Precedence = ucPrecedenceE(ucParamStr(1, t), ucParam(2, t), t.ucThread)
    End Function

    Private Function uc_PrecedenceMax(ByRef t As ucThreadType) As Double
        uc_PrecedenceMax = t.PrecedenceMax
    End Function

    Private Function uc_PrecedenceMin(ByRef t As ucThreadType) As Double
        uc_PrecedenceMin = t.PrecedenceMin
    End Function

    Public Function ucEvaluateCplx(ByVal ExpressionPtr As Integer, ByRef ucValue As ucComplexNumberType, Optional ByVal t As Integer = 0) As Double
        ucValue.Real = ucEvaluate(ExpressionPtr)
        ucValue.Imag = ucImagPartE(ucThreadAddr(t))
        ucEvaluateCplx = ucValue.Real
    End Function

#If ucAltErrMsg = 0 Then
    Public Function ucGetErrorMessage(Optional ByVal ErrorNumber As Integer = -1, Optional ByVal t As Integer = 0) As String
        Dim ErrMsg As String

        ucGetThreadInfo(0, t0)
        If ErrorNumber = -1 Then ErrorNumber = t0.ErrorNumber

        Select Case ErrorNumber
            Case ucErr_None
                ' No Error
            Case ucErr_ucErrorData
                ErrMsg = ucErrorData(0, t)
            Case ucErr_SyntaxError
                ErrMsg = "Syntax error"
            Case ucErr_MismatchedParenth
                ErrMsg = "Mismatched parenthesis"
            Case ucErr_MismatchedQuotes
                ErrMsg = "Mismatched quotes"
            Case ucErr_UndefinedVariable
                ErrMsg = "Undefined variable"
            Case ucErr_UndefinedFunction
                ErrMsg = "Undefined function"
            Case ucErr_IncorrectArgType
                ErrMsg = "Incorrect argument type"
            Case ucErr_InvalidNumberOfArgs
                ErrMsg = "Invalid number of function arguments"
            Case ucErr_InvalidOperandType
                ErrMsg = "Invalid operand type"
            Case ucErr_InvalidVariableName
                ErrMsg = "Invalid variable name"
            Case ucErr_ImplicitMult
                ErrMsg = "Implicit multiplication error"
            Case ucErr_IncompleteBlock
                ErrMsg = "Incomplete syntax block"

            Case ucErr_InvalidOperation
                ErrMsg = "Invalid floating point operation"
            Case ucErr_DenormalOperand
                ErrMsg = "Denormal floating point operand"
            Case ucErr_DivisionByZero
                ErrMsg = "Division by 0"
            Case ucErr_Overflow
                ErrMsg = "Floating point overflow"
            Case ucErr_Underflow
                ErrMsg = "Floating point underflow"
            Case ucErr_InexactResult
                ErrMsg = "Inexact floating point result"
            Case ucErr_SubscriptOutOfRange
                ErrMsg = "Array subscript out of range"
            Case ucErr_StackOverflow
                ErrMsg = "Stack overflow"

            Case ucErr_OperationDenied
                ErrMsg = "Cannot perform requested operation"
            Case ucErr_PropertyConflict
                ErrMsg = "Definition property conflict"
            Case ucErr_ConstantWriteDenied
                ErrMsg = "Assignment to a constant not allowed"
            Case ucErr_FunctionDefError
                ErrMsg = "Invalid function or operator definition"
            Case ucErr_FunctionLocked
                ErrMsg = "Function or operator is locked"

            Case ucErr_DefinitionSpaceFull
                ErrMsg = "Definition space is full"
            Case ucErr_ThreadInitFailed
                ErrMsg = "Thread initialization failed"
            Case ucErr_UnsupportedFeature
                ErrMsg = "Requires advanced edition of UCalc FMP"
            Case Else
                ErrMsg = "Unknown error"
                ' numbers up to 500 are reserved for future use by UCalc
                ' Use Case 501 and beyond for user-defined errors
        End Select

        If ErrorNumber > 1 _
        Then ErrMsg = "Error #" + LTrim$(Str$(ErrorNumber)) + ": " + ErrMsg

        ucGetErrorMessage = ErrMsg
    End Function

    Public Function ucErrorMessage(Optional ByVal ErrorNumber As Integer = -1, Optional ByVal t As Integer = 0) As String
        ucErrorMessage = ucGetErrorMessage(ErrorNumber, t)
    End Function

#End If

    Public Function ucThreadAddr(ByVal t As Integer) As Integer
        If ucInitialized = False Then Call ucEvaluateInit()
        If t = 0 Then ucSetThreadData(0, t0)
        ucThreadAddr = ucThreadAddrE(t)
    End Function

    Public Sub ucEvaluateInit()
        ucInitialized = True
        ucReset()
    End Sub
End Module