//---------------------------------------------------------------------------
#include <vcl.h>
#include <objbase.h>
#pragma hdrstop

#include "DemoCPP.h"
#include "ucalc.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

long OtherProperties;
long double H, W;
void PopulateComboBoxes();
void CartesianLineTo(long double a, long double b);
long double _stdcall ucalcAverage(ucThreadType& t);
long double _stdcall ucalcSum(ucThreadType& t);
long double _stdcall ucArraySum(ucThreadType& t);
long _stdcall ErrorHandler(ucThreadType& t);

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Edit1->Text = ucEvalStr(ComboBox1->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   Image1->Canvas->Rectangle(0, 0, Image1->Width, Image1->Height);
   PopulateComboBoxes();

   ucEvalStr("Initialize the parser class");

   ucDefineConstant("Div0 = 4");  // Div0 = ucFPU_ErrMask_ZeroDivide;
   ucDefineFunction("Average()", ucalcAverage);
   ucDefineFunction("ArraySum(Values())", ucArraySum);
   ucDefineFunction("Sum(Expr&,start,finish,step=1,var@=x)", ucalcSum);
   ucErrorHandler(ErrorHandler);

   OtherProperties = ucOverload + ucComplex + ucRecursion + ucOverwrite + ucOverride;
   t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties;
}
//---------------------------------------------------------------------------

void PopulateComboBoxes()
{
   Form1->ComboBox1->Items->Add("3+4/5-8");
   Form1->ComboBox1->Items->Add("5*(((10+3)!-1) MOD 7)^2");
   Form1->ComboBox1->Items->Add("#b101.1101 + #b110.1001");
   Form1->ComboBox1->Items->Add("(3+4#i)^2");
   Form1->ComboBox1->Items->Add("Sqr(-1)");
   Form1->ComboBox1->Items->Add("\"This\" > \"That\"");
   Form1->ComboBox1->Items->Add("\"This\" < \"That\"");
   Form1->ComboBox1->Items->Add("1/0");
   Form1->ComboBox1->Items->Add("SetOrFPU(Div0, -1/0)");
   Form1->ComboBox1->Items->Add("SetXorFPU(Div0, -1/0)");
   Form1->ComboBox1->Items->Add("");
   Form1->ComboBox1->Items->Add("// -- sum() and average() are defined in");
   Form1->ComboBox1->Items->Add("// -- the source code.  See DEMOCPP.CPP.");
   Form1->ComboBox1->Items->Add("sum(x^2+5,1,10)");
   Form1->ComboBox1->Items->Add("sum(2y-3,1,10,,y)");
   Form1->ComboBox1->Items->Add("sum(x+10,2,5,.5)");
   Form1->ComboBox1->Items->Add("average(5,min(2,5),8)-max(2,5,9,1)");
   Form1->ComboBox1->Items->Add("");

   Form1->ComboBox2->Items->Add("MyVariable = 100");
   Form1->ComboBox2->Items->Add("MyString = 'This is my string' ");
   Form1->ComboBox2->Items->Add("i = #i");
   Form1->ComboBox2->Items->Add("Price As Currency = 137.52");
   Form1->ComboBox2->Items->Add("MyArray() = {57, 23, 98, 17, 46}");
   Form1->ComboBox2->Items->Add("");

   Form1->ComboBox3->Items->Add("fract(x)=abs(abs(x)-int(abs(x)))");
   Form1->ComboBox3->Items->Add("concat$(txtA$,txtB$) = txtA+txtB");
   Form1->ComboBox3->Items->Add("TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Overloading a function with 2 definitions");
   Form1->ComboBox3->Items->Add("area(length,width)=length*width");
   Form1->ComboBox3->Items->Add("area(side) = side^2");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Function with optional argument");
   Form1->ComboBox3->Items->Add("volume(r,h=0)=iif(h=0,pi*r^3*4/3,pi*r^2*h/3)");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Recursive function definition");
   Form1->ComboBox3->Items->Add("Factorial(x) = iif(x=0, 1, x*Factorial(x-1))");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Operator definitions");
   Form1->ComboBox3->Items->Add("Note: shl may have already been defined by add-on");
   Form1->ComboBox3->Items->Add("shl[x,y]      =      x * 2^y");
   Form1->ComboBox3->Items->Add("![x]            =      x == 0");
   Form1->ComboBox3->Items->Add("!=[x,y]       =      x <> y");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("' -- Macro definitions");
   Form1->ComboBox3->Items->Add("Macro MyMacro(x, y) = x + y");
   Form1->ComboBox3->Items->Add("Macro [x]~ = x!");
   Form1->ComboBox3->Items->Add("");
   Form1->ComboBox3->Items->Add("// -- Complex # function definition");
   Form1->ComboBox3->Items->Add("cnj(x)= x.Real + (-x.Imag)*#i");

   Form1->ComboBox4->Items->Add("fract(150/17)+MyVariable");
   Form1->ComboBox4->Items->Add("area(4)+area(5,10)+max(5,9,3)");
   Form1->ComboBox4->Items->Add("volume(4)+volume(4,5)");
   Form1->ComboBox4->Items->Add("2*cnj(3+4#i)");
   Form1->ComboBox4->Items->Add("ArraySum(MyArray())");
   Form1->ComboBox4->Items->Add("Sum(MyArray(x),1,3)");
   Form1->ComboBox4->Items->Add("MyMacro(3, 4)~");
   Form1->ComboBox4->Items->Add("");
   Form1->ComboBox4->Items->Add("// -- Note: Some functions such");
   Form1->ComboBox4->Items->Add("// -- as Sum(), ArraySum() and others");
   Form1->ComboBox4->Items->Add("// -- are defined at the source code level.");
}

long double _stdcall ucalcSum(ucThreadType& t)
{
   DWORD ExpressionPtr;
   long VariableHandle;
   long double x, sstep, Start, Finish, Total;

   ExpressionPtr  = ucParam(1, t);
   Start          = ucParam(2, t);
   Finish         = ucParam(3, t);
   sstep          = ucParam(4, t);
   VariableHandle = ucParam(5, t);

   Total = 0;
   x = Start;

   while (x <= Finish)
   {
      ucSetVariableValue(VariableHandle, x);
      Total = Total + ucEvaluate(ExpressionPtr);
      x = x + sstep;
   }

   return Total;
}

long double _stdcall ucArraySum(ucThreadType& t)
{
   double *ValueArrayDbl;
   long double *ValueArrayExt;
   unsigned long BaseAddress;
   long DataType, ArrayHandle, UpperBound, x;
   double Total = 0;

   ArrayHandle = ucParam(1, t);
   BaseAddress = ucArrayInfo(ArrayHandle, ucArray_DataAddress);
   UpperBound  = ucArrayInfo(ArrayHandle, ucArray_ElementCount)-1;
   DataType    = ucArrayInfo(ArrayHandle, ucArray_DataType);

   ValueArrayDbl = (double *) BaseAddress;
   ValueArrayExt = (long double *) BaseAddress;

   for(x = 0; x <= UpperBound; x++)
   {
      if (DataType == ucType_FloatDouble) Total = Total + ValueArrayDbl[x];
      if (DataType == ucType_FloatExtended) Total = Total + ValueArrayExt[x];
   }

   return Total;
}

long double _stdcall ucalcAverage(ucThreadType& t)
{
   long x;
   long double Total = 0;

   for(x = 1; x <= t.ParamCount; x++)
      Total = Total + ucParam(x, t);

   return Total / t.ParamCount;
}

long _stdcall ErrorHandler(ucThreadType& t)
{
   char ErrorMessage[80];

   if (t.Context & ucContext_ucParseOrucEval) {
      strcpy(ErrorMessage, ucErrorMessage(t.ErrorNumber, t.ucThread));
      strcat(ErrorMessage, "\nData: ");
      if (ucErrorData(0, t.ucThread) != NULL)
         strcat(ErrorMessage, ucErrorData(0, t.ucThread));
      MessageDlg(ErrorMessage, mtConfirmation, TMsgDlgButtons()
   << mbOK, 0);
   }
   return 0;
}

void CartesianLineTo(long double a, long double b)
{
   int x, y;

   x = W * (a + 10) / 20;
   y = H * (2 - b) / 4;
   Form1->Image1->Canvas->LineTo(x, y);
}

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   Edit3->Text = ucEvalStr(ComboBox4->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   ucDefineVariable(ComboBox2->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   ucDefineFunction(ComboBox3->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   long double x = -10;
   long UserEq;

   Image1->Canvas->FillRect(ClientRect);
   UserEq = ucParse(Edit7->Text.c_str(), "x");
   ucAttachVariable("x", &x, UserEq);

   W = Image1->Width;
   H = Image1->Height;

   Image1->Canvas->MoveTo(0, H/2);

   while (x <= 10)
   {
      CartesianLineTo(x, ucEvaluate(UserEq));
      x = x + 0.125;
   }

   ucReleaseExprPtr(UserEq);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
   long double x = 1, Sum = 0;
   long UserEq, finalValue;
   TDateTime TimerStart, Elapsed;
   AnsiString HourStr, MSecStr;
   Word Hour, Min, Sec, MSec;

   Edit10->Text = "";
   Edit10->Refresh();

   TimerStart = Time();
   finalValue = StrToFloat(Edit9->Text);

   UserEq = ucParse(Edit8->Text.c_str(), "x");
   ucAttachVariable("x", &x, UserEq);

   if (CheckBox2->Checked == True)
      t0.ucProperty.FPU_Turbo = ucFPU_SkipSet + ucFPU_SkipReset;

   while (x <= finalValue)
   {
      Sum = Sum + ucEvaluate(UserEq);
      x++;
   }

   Elapsed = Time() - TimerStart;
   DecodeTime(Elapsed, Hour, Min, Sec, MSec);
   HourStr = IntToStr(Sec);
   MSecStr = IntToStr(MSec);    

   Edit10->Text = HourStr + "." + MSecStr + " sec / " + FormatFloat("#", Sum);
   ucReleaseExprPtr(UserEq);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   if (CheckBox1->Checked == True)
      t0.ucProperty.FunctionProperties = ucDynamic + OtherProperties;
   else
      t0.ucProperty.FunctionProperties = ucInline + OtherProperties;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
   // See TForm1::Button6Click    
}
//---------------------------------------------------------------------------

