// ucalc.cpp : Implementation file
// Designed to work with 32-bit MS Visual C++ and Borland C++ Builder.
//
// UCalc Fast Math Parser (Beta N)
// Copyright (c) 1998-2005 by Daniel Corbier.  All rights reserved.
// http://www.ucalc.com/mathparser

#include "ucalc.h"

long ucInitialized = 0;
long ucLoadLibFailed;

ucThreadType t0;
ucHandleType *ucItem;

UCARRAYINFOE ucArrayInfoE;
UCALIASE ucAliasE;
UCDETACHSYMBOLE ucDetachSymbolE;
UCDEFINEE ucDefineE;
UCDEFINEFUNCTIONE ucDefineFunctionE;
UCDEFINEVARIABLEE ucDefineVariableE;
UCERRORCLEARE ucErrorClearE;
UCEVALE ucEvalE;
UCEVALSTRE ucEvalStrE;
UCEVALUATEE ucEvaluateE;
UCEVALUATELNGE ucEvaluateLngE;
UCEVALUATEFXTE ucEvaluateFxtE;
UCEVALUATEINITE ucEvaluateInitE;
UCEVALUATESTRE ucEvaluateStrE;
UCGETERRORDATAE ucGetErrorDataE;
UCGETPARAME ucGetParamE;
UCGETPARAMCPLXE ucGetParamCplxE;
UCGETPARAMSTRE ucGetParamStrE;
UCTHREADADDRE ucThreadAddrE;
UCTREEGETPARAME ucTreeGetParamE;
UCTREEPROPERTYE ucTreePropertyE;
UCGETTHREADINFOE ucGetThreadInfoE;
UCGETVARIABLEVALUEE ucGetVariableValueE;
UCGETVARIABLEVALUESTRE ucGetVariableValueStrE;
UCIMAGPARTE ucImagPartE;
UCLICENSEE ucLicenseE;
UCLOWERBOUNDE ucLowerBoundE;
UCNEWTHREADE ucNewThreadE;
UCNEWSYMBOLHANDLEE ucNewSymbolHandleE;
UCOPE ucOpE;
UCPARAMHANDLEE ucParamHandleE;
UCPARAMTYPEE ucParamTypeE;
UCPARSEE ucParseE;
UCPRECEDENCEE ucPrecedenceE;
UCSETCALLBACKE ucSetCallbackE;
UCRELEASEEXPRPTRE ucReleaseExprPtrE;
UCRELEASEITEME ucReleaseItemE;
UCRELEASETHREADE ucReleaseThreadE;
UCRESETE ucResetE;
UCRETURNE ucReturnE;
UCRETURNCPLXE ucReturnCplxE;
UCRETURNSTRE ucReturnStrE;
UCSETERRORDATAE ucSetErrorDataE;
UCSETPARAMSTRE ucSetParamStrE;
UCTREESETPARAME ucTreeSetParamE;
UCSETTHREADADDRE ucSetThreadAddrE;
UCSETTRIGMODEE ucSetTrigModeE;
UCSETVARIABLEVALUEE ucSetVariableValueE;
UCSETVARIABLEVALUESTRE ucSetVariableValueStrE;
UCSYMBOLHANDLEE ucSymbolHandleE;
UCUPPERBOUNDE ucUpperBoundE;

long ucEvaluateInit()
{
   HINSTANCE hDLL;
   HINSTANCE hDLLe;
   long HostFPUWord;

   hDLL  = LoadLibrary("ucalcfmp.dll");
   hDLLe = LoadLibrary("ucalcfme.dll");
   if ((hDLL == NULL) || (hDLLe == NULL))
   {
      ucLoadLibFailed = 1;
      return 0;
      // Host program should check LoadLibraryFailed() before continuing
   }

   ucArrayInfoE = (UCARRAYINFOE)GetProcAddress(hDLL,"ucArrayInfoE");
   ucAliasE = (UCALIASE)GetProcAddress(hDLL,"ucAliasE");
   ucDetachSymbolE = (UCDETACHSYMBOLE)GetProcAddress(hDLL,"ucDetachSymbolE");
   ucDefineE = (UCDEFINEE)GetProcAddress(hDLL,"ucDefineE");
   ucDefineFunctionE = (UCDEFINEFUNCTIONE)GetProcAddress(hDLL,"ucDefineFunctionE");
   ucDefineVariableE = (UCDEFINEVARIABLEE)GetProcAddress(hDLL,"ucDefineVariableE");
   ucErrorClearE = (UCERRORCLEARE)GetProcAddress(hDLL,"ucErrorClearE");
   ucEvalE = (UCEVALE)GetProcAddress(hDLL,"ucEvalE");
   ucEvalStrE = (UCEVALSTRE)GetProcAddress(hDLL,"ucEvalStrE");
   ucEvaluateStrE = (UCEVALUATESTRE)GetProcAddress(hDLL,"ucEvaluateStrE");
   ucGetErrorDataE = (UCGETERRORDATAE)GetProcAddress(hDLL,"ucGetErrorDataE");
   ucGetParamE = (UCGETPARAME)GetProcAddress(hDLL,"ucGetParamE");
   ucGetParamCplxE = (UCGETPARAMCPLXE)GetProcAddress(hDLL,"ucGetParamCplxE");
   ucGetParamStrE = (UCGETPARAMSTRE)GetProcAddress(hDLL,"ucGetParamStrE");
   ucTreeGetParamE = (UCTREEGETPARAME)GetProcAddress(hDLL,"ucTreeGetParamE");
   ucTreePropertyE = (UCTREEPROPERTYE)GetProcAddress(hDLL,"ucTreePropertyE");
   ucGetThreadInfoE = (UCGETTHREADINFOE)GetProcAddress(hDLL,"ucGetThreadInfoE");
   ucGetVariableValueE = (UCGETVARIABLEVALUEE)GetProcAddress(hDLL,"ucGetVariableValueE");
   ucGetVariableValueStrE = (UCGETVARIABLEVALUESTRE)GetProcAddress(hDLL,"ucGetVariableValueStrE");
   ucImagPartE = (UCIMAGPARTE)GetProcAddress(hDLL,"ucImagPartE");
   ucLicenseE = (UCLICENSEE)GetProcAddress(hDLL,"ucLicenseE");
   ucLowerBoundE = (UCLOWERBOUNDE)GetProcAddress(hDLL,"ucLowerBoundE");
   ucNewThreadE = (UCNEWTHREADE)GetProcAddress(hDLL,"ucNewThreadE");
   ucNewSymbolHandleE = (UCNEWSYMBOLHANDLEE)GetProcAddress(hDLL,"ucNewSymbolHandleE");
   ucOpE = (UCOPE)GetProcAddress(hDLL,"ucOpE");
   ucParamHandleE = (UCPARAMHANDLEE)GetProcAddress(hDLL,"ucParamHandleE");
   ucParamTypeE = (UCPARAMTYPEE)GetProcAddress(hDLL,"ucParamTypeE");
   ucParseE = (UCPARSEE)GetProcAddress(hDLL, "ucParseE");
   ucPrecedenceE = (UCPRECEDENCEE)GetProcAddress(hDLL, "ucPrecedenceE");
   ucSetCallbackE = (UCSETCALLBACKE)GetProcAddress(hDLL,"ucSetCallbackE");
   ucReleaseItemE = (UCRELEASEITEME)GetProcAddress(hDLL,"ucReleaseItemE");
   ucReleaseThreadE = (UCRELEASETHREADE)GetProcAddress(hDLL,"ucReleaseThreadE");
   ucResetE = (UCRESETE)GetProcAddress(hDLL,"ucResetE");
#if defined(__BORLANDC__)
   ucReturnE = (UCRETURNE)GetProcAddress(hDLL,"ucReturnE");
   ucReturnCplxE = (UCRETURNCPLXE)GetProcAddress(hDLL,"ucReturnCplxE");
#else
   ucReturnE = (UCRETURNE)GetProcAddress(hDLL,"ucReturnDblE");
   ucReturnCplxE = (UCRETURNCPLXE)GetProcAddress(hDLL,"ucReturnCplxDblE");
#endif
   ucReturnStrE = (UCRETURNSTRE)GetProcAddress(hDLL,"ucReturnStrE");
   ucSetErrorDataE = (UCSETERRORDATAE)GetProcAddress(hDLL,"ucSetErrorDataE");
   ucSetParamStrE = (UCSETPARAMSTRE)GetProcAddress(hDLL,"ucSetParamStrE");
   ucThreadAddrE = (UCTHREADADDRE)GetProcAddress(hDLL,"ucThreadAddrE");
   ucTreeSetParamE = (UCTREESETPARAME)GetProcAddress(hDLL,"ucTreeSetParamE");
   ucSetThreadAddrE = (UCSETTHREADADDRE)GetProcAddress(hDLL,"ucSetThreadAddrE");
   ucSetTrigModeE = (UCSETTRIGMODEE)GetProcAddress(hDLL,"ucSetTrigModeE");
#if defined(__BORLANDC__)
   ucSetVariableValueE = (UCSETVARIABLEVALUEE)GetProcAddress(hDLL,"ucSetVariableValueE");
#else
   ucSetVariableValueE = (UCSETVARIABLEVALUEE)GetProcAddress(hDLL,"ucSetVariableValueDblE");
#endif
   ucSetVariableValueStrE = (UCSETVARIABLEVALUESTRE)GetProcAddress(hDLL,"ucSetVariableValueStrE");
   ucSymbolHandleE = (UCSYMBOLHANDLEE)GetProcAddress(hDLL,"ucSymbolHandleE");
   ucUpperBoundE = (UCUPPERBOUNDE)GetProcAddress(hDLL,"ucUpperBoundE");

   // The following 3 routines come from ucalcfmE.dll instead of ucalcfmP.dll
   ucEvaluateE = (UCEVALUATEE)GetProcAddress(hDLLe,"ucEvaluateE");
   ucEvaluateLngE = (UCEVALUATELNGE)GetProcAddress(hDLLe,"ucEvaluateLngE");
   ucEvaluateFxtE = (UCEVALUATEFXTE)GetProcAddress(hDLLe,"ucEvaluateFxtE");
   ucEvaluateInitE = (UCEVALUATEINITE)GetProcAddress(hDLLe,"ucEvaluateInitE");
   ucReleaseExprPtrE = (UCRELEASEEXPRPTRE)GetProcAddress(hDLLe,"ucReleaseExprPtrE");

//+++#if defined(__BORLANDC__)
   // For C++ compilers that support long double (80 bit precision).
   // This includes Borland C++ Builder.

//   HostFPUWord = Default8087CW;
//#else
   // For MS Visual C++ 6.0 and other compilers which do not support 80 bit
   // precision.  Microsoft's "long double" is really the same as "double".

   HostFPUWord = ucFPU_Round_Even
   + ucFPU_Precision_Double
   + ucFPU_ErrMask_InvalidOp
   + ucFPU_ErrMask_DenormalOp
   + ucFPU_ErrMask_ZeroDivide
   + ucFPU_ErrMask_Overflow
   + ucFPU_ErrMask_Underflow
   + ucFPU_ErrMask_PrecisionLoss;
   // Note: Although the above is the same setting as CW_DEFAULT,
   // do not set HostFPUWord = CW_DEFAULT, because the
   // HostFPUWord value is for Pentiums, and CW_DEFAULT is for the 386.
//#endif

   ucInitialized = 1;
   ucGetThreadInfo(0, t0);
   ucSetThreadAddr(0, t0);
   ucReset(t0);
// ucNewThreadE();

   t0.ucProperty.FPU_ControlWord_HostProgram = HostFPUWord;

   return 0;
}

long ucElementCategory(ucThreadType& t)
{
   return ucTreePropertyE(0, 0, ucElementCat, t);
}

long ucNewSymbolHandle(ucThreadType& t)
{
   return ucNewSymbolHandleE(t);
}

long ucParamHandle(long pIndex, ucThreadType& t)
{
   return ucParamHandleE(pIndex, t);
}

long ucParamType(long pIndex, ucThreadType& t)
{
   return ucParamTypeE(pIndex, t);
}

long double ucParam(long x, ucThreadType& t)
{
   return ucGetParamE(x, t);
}
long double ucParamCplx(long x, ucThreadType& t)
{
   return ucGetParamCplxE(x, t);
}

char* ucGetParamStr(long ParamIndex, ucThreadType& t)
{
   return ucGetParamStrE(ParamIndex, t);
}

char* ucParamStr(long ParamIndex, ucThreadType& t)
{
   return ucGetParamStrE(ParamIndex, t);
}

char* ucGetExpr(ucThreadType& t)
{
   return ucTreeGetParamE(-1, t);
}

char* ucTreeGetExpr(ucThreadType& t)
{
   return ucTreeGetParamE(-1, t);
}

char* ucTreeGetFunc(ucThreadType& t)
{
   return ucTreeGetParamE(0, t);
}

char* ucTreeGetOp(ucThreadType& t)
{
   return ucTreeGetParamE(0, t);
}

char* ucTreeGetParam(long pIndex, ucThreadType& t)
{
   return ucTreeGetParamE(pIndex, t);
}

char* ucTreeGetParamList(ucThreadType& t)
{
   return ucTreeGetParamE(-2, t);
}

void ucSetExpr(const char* Expression, ucThreadType& t)
{
   ucTreeSetParamE(-1, Expression, t);
}

void ucTreeSetExpr(const char* Expression, ucThreadType& t)
{
   ucTreeSetParamE(-1, Expression, t);
}

DWORD ucThreadAddr(long t)
{
   if (ucInitialized == 0) ucEvaluateInit();
   return ucThreadAddrE(t);
}

void ucTreeSetFunc(const char* TreeFunc, ucThreadType& t)
{
   ucTreeSetParamE(0, TreeFunc, t);
}

void ucTreeSetOp(const char* TreeOp, ucThreadType& t)
{
   ucTreeSetParamE(0, TreeOp, t);
}

void ucTreeSetParam(long pIndex, const char* pData, ucThreadType& t)
{
   ucTreeSetParamE(pIndex, pData, t);
}

void ucTreeSetParamList(const char* pData, ucThreadType& t)
{
   ucTreeSetParamE(-2, pData, t);
}

long ucTreeProperty(DWORD NodePtr, long pIndex, long pOption, ucThreadType& t)
{
   return ucTreePropertyE(NodePtr, pIndex, pOption, t);
}

long ucTreeNodeProperty(long pOption, ucThreadType& t)
{
   return ucTreePropertyE(0, 0, pOption, t);
}

long ucTreeParamProperty(long pIndex, long pOption, ucThreadType& t)
{
   return ucTreePropertyE(0, pIndex, pOption, t);
}

long ucTreeParentProperty(long pOption, ucThreadType& t)
{
   DWORD ParentPtr;

   ParentPtr = ucTreePropertyE(0, 0, ucParentPtr, t);
   return ucTreePropertyE(ParentPtr, 0, pOption, t);
}

void ucLicense(const char* SerialNumber)
{
   ucLicenseE(SerialNumber);
}

void ucSetParamStr(long ParamIndex, const char* ArgStr, ucThreadType& t)
{
   ucSetParamStrE(ParamIndex, ArgStr, t);
}

ucNUM uc_Precedence(ucThreadType& t)
{
   return ucPrecedenceE(ucParamStr(1, t), ucParam(2, t), t.ucThread);
}

ucNUM uc_PrecedenceMax(ucThreadType& t)
{
   return t.PrecedenceMax;
}

ucNUM uc_PrecedenceMin(ucThreadType& t)
{
   return t.PrecedenceMin;
}

void ucReturn(long double vValue, ucThreadType& t)
{
   ucReturnE(vValue, t);
}

void ucReturnCplx(long double vValue, ucThreadType& t)
{
   ucReturnCplxE(vValue, t);
}

void ucReturnStr(const char* Expression, ucThreadType& t)
{
   ucReturnStrE(Expression, t);
}

void ucSetThreadAddr(long ucThread, ucThreadType& t)
{
   ucSetThreadAddrE(ucThread, t);
}

void ucSetTrigMode(long TrigMode, ucThreadType& t)
{
   ucSetTrigModeE(TrigMode, ucThreadAddr(t.ucThread));
}

void ucSetErrorData(long errIndex, const char* vValue, ucThreadType& t)
{
   ucSetErrorDataE(errIndex, vValue, t);
}



//  These function definitions are for single-thread and/or startup usage only

DWORD ucArrayInfo(long VarHandle, long InfoOption)
{
   return ucArrayInfoE(VarHandle, InfoOption);
}

long ucDefineConstant(const char* ConstantDef, long vProperties = 0)
{
   return ucDefineVariableE(ConstantDef, 0, 0, vProperties+ucConstant, t0.ucProperty.DefaultNumericType, ucThreadAddr(0));
}

long ucDefine(const char* Definition)
{
   return ucDefineE(Definition, ucThreadAddr(0));
}

long ucDefineFunction(const char* FunctionDef, void *FunctionAddress = 0, long fProperties = 0, long vType = 0)
{
   return ucDefineFunctionE(FunctionDef, reinterpret_cast<DWORD>(FunctionAddress), 0, fProperties, vType, ucThreadAddr(0));
}

long ucDefineMacro(const char* Definition)
{
   char Def[1000];
   strcpy(Def, "Macro ");
   strcat(Def, Definition);
   return ucDefineE(Def, ucThreadAddr(0));
}

long ucDefineOperator(const char* OperatorDef, long Precedence = 0, void *OperatorAddress = 0, long fProperties = 0, long vType = 0)
{
   return ucDefineFunctionE(OperatorDef, reinterpret_cast<DWORD>(OperatorAddress), Precedence, fProperties, vType, ucThreadAddr(0));
}

long ucDefineSyntax(const char* Definition)
{
   char Def[1000];
   strcpy(Def, "Syntax ");
   strcat(Def, Definition);
   return ucDefineE(Def, ucThreadAddr(0));
}

long ucDefineVariable(const char* VariableDef, long vProperties = 0, long ucThread = 0)
{
   return ucDefineVariableE(VariableDef, 0, 0, vProperties, t0.ucProperty.DefaultNumericType, ucThreadAddr(ucThread));
}

long ucAttachVariable(const char* VariableDef, void* vPtr, DWORD ExprPtr = 0, long vProperties = 0, long t = 0)
{
   return ucDefineVariableE(VariableDef, reinterpret_cast<DWORD>(vPtr), ExprPtr, vProperties, t0.ucProperty.DefaultNumericType, ucThreadAddr(t));
}

long ucError(void)
{   
   return t0.ErrorNumber;
}

char* ucErrorData(long errIndex, long t = 0)
{
   return ucGetErrorDataE(errIndex, ucThreadAddr(t));
}

long double ucEval(const char* Expression, long t = 0)
{
   return ucEvalE(Expression, ucThreadAddr(t));
}

char* ucEvalStr(const char* Expression, long t = 0)
{
   return ucEvalStrE(Expression, ucThreadAddr(t));
}

long double ucEvaluate(DWORD ExpressionPtr)
{
   return ucEvaluateE(ExpressionPtr);
}

long double ucEvaluateLng(DWORD ExpressionPtr)
{
   return ucEvaluateLngE(ExpressionPtr);
}

#if defined(__BORLANDC__)
long double ucEvaluateFxt(DWORD ExpressionPtr)
{
   return ucEvaluateFxtE(ExpressionPtr);
}
#endif

long double ucEvaluate(DWORD ExpressionPtr, ucComplexNumberType& ucValue, long t = 0)
{
   long double ucResult;

   ucResult = ucEvaluateE(ExpressionPtr);
   ucValue.Real = ucResult;
   ucValue.Imag = ucImagPartE(ucThreadAddr(t));

   return ucResult;
}

long double ucEvaluateCplx(DWORD ExpressionPtr, ucComplexNumberType& ucValue, long t = 0)
{
   long double ucResult;

   ucResult = ucEvaluateE(ExpressionPtr);
   ucValue.Real = ucResult;
   ucValue.Imag = ucImagPartE(ucThreadAddr(t));

   return ucResult;
}

char* ucEvaluateStr(DWORD ExpressionPtr)
{
   return ucEvaluateStrE(ExpressionPtr);
}

char* ucGetErrorData(long errIndex, long t = 0)
{
   return ucGetErrorDataE(errIndex, ucThreadAddr(t));
}

DWORD ucGetThreadInfo(long ucThread, ucThreadType& t)
{
   return ucGetThreadInfoE(ucThread, t);
}

long double ucGetVariableValue(long VarHandle)
{
   return ucGetVariableValueE(VarHandle);
}

char* ucGetVariableValueStr(long VarHandle)
{
   return ucGetVariableValueStrE(VarHandle);
}

char* ucVariableValueStr(long VarHandle)
{
   return ucGetVariableValueStrE(VarHandle);
}

long double ucImagPart(long t = 0)
{
   return ucImagPartE(ucThreadAddr(t));
}

long ucLowerBound(long VarHandle, long Dimension = 1)
{
   return ucLowerBoundE(VarHandle, Dimension);
}

void* ucOp(DWORD OpID)
{
   return (void*)ucOpE(OpID);
}

DWORD ucParse(const char* Expression, const char* LocalVars = "", long ExprType = 0)
{
   return ucParseE(Expression, LocalVars, ExprType, ucThreadAddr(0));
}

long ucPrecedence(const char* Op, long OpCategory = 0, long t = 0)
{
   return ucPrecedenceE(Op, OpCategory, ucThreadAddr(t));
}

long ucUpperBound(long VarHandle, long Dimension = 1)
{
   return ucUpperBoundE(VarHandle, Dimension);
}

long ucSymbolHandle(const char* ucSymbol, long SymbolProperty = 0, long t = 0)
{
   return ucSymbolHandleE(ucSymbol, SymbolProperty, ucThreadAddr(t));
}


long ucAlias(const char* AssignFrom, const char* AssignTo, long aProperties = 0, long Precedence = 0)
{
   return ucAliasE(AssignFrom, AssignTo, aProperties, Precedence, ucThreadAddr(0));
}

void ucDetachSymbol(const char* Symbol, long t = 0)
{
   ucDetachSymbolE(Symbol, ucThreadAddr(t));
}

void ucErrorClear(long t = 0)
{
   ucErrorClearE(ucThreadAddr(t));
}

long ucErrorHandler(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucErrorCallback, ucThreadAddr(0));
}

long ucPreParse(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreePre, ucThreadAddr(0));
}

long ucTreeParseDownEarly(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeDownEarly, ucThreadAddr(0));
}

long ucTreeParseDown(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeDown, ucThreadAddr(0));
}

long ucTreeParseUp(void *FunctionAddress)
{
   return ucSetCallbackE(reinterpret_cast<DWORD>(FunctionAddress), ucTreeUp, ucThreadAddr(0));
}

void ucReleaseItem(long ItemHandle)
{
   ucReleaseItemE(ItemHandle);
}

void ucReleaseExprPtr(DWORD ExpressionPtr)
{
   ucReleaseExprPtrE(ExpressionPtr);
}

void ucSetVariableValue(long VarHandle, long double vValue)
{
   ucSetVariableValueE(VarHandle, vValue);
}

void ucSetVariableValueStr(long VarHandle, const char* vValue)
{
   ucSetVariableValueStrE(VarHandle, vValue);
}

void ucReset(ucThreadType& t)
{
   long Between_Mult_Pow, Between_And_Less, Between_Div_Mod;

   ucItem = (ucHandleType *)calloc(1+t.ucProperty.DefSpace.BaseDefinitionSpace
             +t.ucProperty.DefSpace.DefinitionSpace
             *t.ucProperty.DefSpace.MaxThreadCount, sizeof(ucHandleType));

   t.Context = t.Context | ucContext_ucReset;
   t.Handshake.LanguageID = uc_Lang_CPlusPlus;
   t.Handshake.HandleAddr = (unsigned long)ucItem;

   ucEvaluateInitE();
   ucResetE(t);

   t.ucProperty.ComplexNumbers = ucTrue;
   t.ucProperty.EscapeChar     = 126; // "~"

   ucDefineConstant("Byte     = uc_Integer8u");
   ucDefineConstant("Integer  = uc_Integer16");
   ucDefineConstant("Word     = uc_Integer16u");
   ucDefineConstant("Long     = uc_Integer32");
   ucDefineConstant("DWord    = uc_Integer32u");
   ucDefineConstant("Quad     = uc_Integer64");
   ucDefineConstant("Currency = uc_Currency");
   ucDefineConstant("CurrencyX= uc_CurrencyExt");
   ucDefineConstant("Single   = uc_FloatSingle");
   ucDefineConstant("Double   = uc_FloatDouble");
   ucDefineConstant("Extended = uc_FloatExtended");
   ucDefineConstant("AsciiZ   = uc_StringLPSTR");
   ucDefineConstant("String   = uc_StringAnsi");
   ucDefineConstant("FixedPt  = Currency");
   ucDefineConstant("Any      = uc_Any");

   Between_Mult_Pow = (ucPrecedence("*") + ucPrecedence("^")) / 2;
   Between_And_Less = (ucPrecedence("AND") + ucPrecedence("<")) / 2;
   Between_Div_Mod  = (ucPrecedence("/") + ucPrecedence("MOD")) / 2;
   
   t.ucProperty.FunctionProperties = ucFastCallback + ucOverload;

   ucDefineOperator("*[x As Long, y As Long] As Long", ucPrecedence("*"), ucOp(Op_Int_Multiply));
   ucDefineOperator("-[x As Long, y As Long] As Long", ucPrecedence("-"), ucOp(Op_Int_Subtract));
   ucDefineOperator("+[x As Long, y As Long] As Long", ucPrecedence("+"), ucOp(Op_Int_Add));
   ucDefineOperator("/[x As Long, y As Long] As Extended", ucPrecedence("/"), ucOp(Op_Int_DivideToExt));
   ucDefineOperator("\\[x As Long, y As Long] As Long", Between_Div_Mod, ucOp(Op_Int_DivideToInt));
   ucDefineOperator("Mod[x As Long, y As Long] As Long", ucPrecedence("MOD"), ucOp(Op_Int_Mod));
   ucDefineOperator("^[x As Extended, y As Long] As Extended", ucPrecedence("^"), ucOp(Op_IntPower));

   ucDefineOperator("*[x As Quad, y As Quad] As Quad", ucPrecedence("*"), ucOp(Op_Qwd_Multiply));
   ucDefineOperator("-[x As Quad, y As Quad] As Quad", ucPrecedence("-"), ucOp(Op_Qwd_Subtract));
   ucDefineOperator("+[x As Quad, y As Quad] As Quad", ucPrecedence("+"), ucOp(Op_Qwd_Add));
   ucDefineOperator("/[x As Quad, y As Quad] As Extended", ucPrecedence("/"), ucOp(Op_Qwd_DivideToExt));
   ucDefineOperator("\\[x As Quad, y As Quad] As Quad", Between_Div_Mod, ucOp(Op_Qwd_DivideToInt));

   ucDefineOperator("*[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("*"), ucOp(Op_Cur_Multiply));
   ucDefineOperator("-[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("-"), ucOp(Op_Cur_Subtract));
   ucDefineOperator("+[x As FixedPt, y As FixedPt] As FixedPt", ucPrecedence("+"), ucOp(Op_Cur_Add));
   ucDefineOperator("/[x As FixedPt, y As FixedPt] As Extended", ucPrecedence("/"), ucOp(Op_Cur_DivideToExt));

   ucDefineFunction("Fact(x As Long)", ucOp(Op_Func_Factorial));
   ucDefineFunction("GetFPU(x As Long) As Long", ucOp(Op_Func_GetFPU));
   ucDefineFunction("SetFPU(x As Long)", ucOp(Op_Func_SetFPU));
   ucDefineFunction("SetOrFPU(x As Long)", ucOp(Op_Func_SetOrFPU));
   ucDefineFunction("SetXorFPU(x As Long)", ucOp(Op_Func_SetXorFPU));
   ucDefineFunction("RestoreFPU(x As Long)", ucOp(Op_Func_RestoreFPU));
   ucDefineFunction("Ceil(x)", ucOp(Op_Func_Ceil));
   ucDefineFunction("Not(x)", ucOp(Op_Func_Not));

   // String relational (comparison) operators
   t.ucProperty.DefaultPrecedence = ucPrecedence("<");
   t.ucProperty.FunctionProperties = ucDynamic + ucLocked + ucOverride + ucOverload;
   ucDefineFunction("StrCmp(a As String, b As String) = StrCmp(0, 0, a, b)");
   ucDefineOperator(" =[a As String, b As String] = StrCmp(a, b) = 2");
   ucDefineOperator("<>[a As String, b As String] = StrCmp(a, b) <> 2");
   ucDefineOperator(" >[a As String, b As String] = StrCmp(a, b) = 3");
   ucDefineOperator(">=[a As String, b As String] = StrCmp(a, b) > 1");
   ucDefineOperator(" <[a As String, b As String] = StrCmp(a, b) = 1");
   ucDefineOperator("<=[a As String, b As String] = StrCmp(a, b) < 3");

   t.ucProperty.FunctionProperties = ucInline+ucLocked+ucOverride+ucOverload;

   ucDefineFunction("Precedence(Operator$, OpCategory = 0)", uc_Precedence);
   ucDefineFunction("PrecedenceMax()", uc_PrecedenceMax);
   ucDefineFunction("PrecedenceMin()", uc_PrecedenceMin);

   ucDefineMacro(".[x]  ::= (0.x) ::: Precedence = PrecedenceMax");
   ucDefineMacro(" [x]. ::= (x.0) ::: Precedence = PrecedenceMax");

   // Hex, binary, octal notations.  Includes support for non-integers
   ucDefineSyntax("#b (Number:'[0-1]+') [(Frac:'\.[0-1]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 2) ::: Precedence = PrecedenceMax");
   ucDefineSyntax("#o (Number:'[0-7]+') [(Frac:'\.[0-7]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 8) ::: Precedence = PrecedenceMax");
   ucDefineSyntax("#h (Number:'[0-9A-F]+') [(Frac:'\.[0-9A-F]+'=)] ::= BaseConvert(~qNumber~jFrac~q, 16) ::: Precedence = PrecedenceMax");
   ucDefineSyntax("#i ::= ~i");

   // Alternative notations
//   ucDefineOperator("  &[a,b] = a and b", ucPrecedence("and"));
//   ucDefineOperator("  |[a,b] = a or  b", ucPrecedence("or "));
//   ucDefineOperator(" =<[a,b] = a <=  b", ucPrecedence("<= "));
//   ucDefineOperator(" =>[a,b] = a >=  b", ucPrecedence(">= "));
   ucDefineOperator(" ==[a,b] = a  =  b", ucPrecedence("="));
   ucDefineOperator("DIV[a,b] = a \\  b", ucPrecedence("\\"));
   ucDefineOperator("**[a,b]  = a  ^  b", ucPrecedence("^"));
   ucDefineMacro(" &[TextA,TextB] = TextA + TextB");
   ucDefineOperator("==[TextA$,TextB$] = TextA = TextB", ucPrecedence("="));
   ucDefineOperator("Imp[a, b] = (Not(a)) Or b", ucPrecedence("OR")-1);
   ucDefineOperator("Eqv[a, b] = (a and b) Or (not(a) and not(b))", ucPrecedence("OR")-1);
   ucDefineFunction("Concatenate$(a$,b$) = a + b");
   ucDefineFunction("Sign(x) = Sgn(x)");
   ucDefineFunction("Sqrt(x) = Sqr(x)");
   ucDefineFunction("Ln(x)   = Log(x)");
   ucDefineFunction("Atan(x) = Atn(x)");
   ucDefineOperator("[x]! = fact(x)", t.PrecedenceMax);
   ucDefineOperator("[x]% = x/100", t.PrecedenceMax);
   ucDefineOperator("%[x,y] = x mod y", ucPrecedence("MOD"));
   ucDefineOperator("-[x] = 0-x", Between_Mult_Pow);
   ucDefineOperator("+[x] = 0+x", Between_Mult_Pow);
   ucDefineOperator("Not[x] = Not(x)", Between_And_Less);

   // FPU routines
   ucDefineFunction("GetFPU() = GetFPU(0)");
   ucDefineFunction("RestoreFPU() = RestoreFPU(0)");
   ucAlias("GetFPU", "GetFPU(0)");
   ucAlias("RestoreFPU", "RestoreFPU(0)");
   ucAlias("SetFPU(setting, Expression)",   "(SetFPU(setting)+(Expression)+RestoreFPU(0))");
   ucAlias("SetOrFPU(setting, Expression)", "(SetOrFPU(setting)+(Expression)+RestoreFPU(0))");
   ucAlias("SetXorFPU(setting, Expression)","(SetXorFPU(setting)+(Expression)+RestoreFPU(0))");

   ucDefineFunction("Inf() = SetOrFPU(4, 1/0)", 0, ucDynamic);
   ucDefineFunction("NaN() = SetOrFPU(1, 0/0)", 0, ucDynamic);

   // Hyperbolic functions
   ucDefineFunction("Sinh(x)  = (exp(x) - exp(-x)) / 2");
   ucDefineFunction("Cosh(x)  = (exp(x) + exp(-x)) / 2");
   ucDefineFunction("Tanh(x)  = (exp(2x) - 1) / (exp(2x) + 1)");
   ucDefineFunction("Coth(x)  = (exp(2x) + 1) / (exp(2x) - 1)");
   ucDefineFunction("Sech(x)  = 2 / (exp(x) + exp(-x))");
   ucDefineFunction("Csch(x)  = 2 / (exp(x) - exp(-x))");
   ucDefineFunction("Asinh(x) = Log(x + Sqr(x ^ 2 + 1))");
   ucDefineFunction("Acosh(x) = Log(x + Sqr(x ^ 2 - 1))");
   ucDefineFunction("Atanh(x) = Log((1 + x) / (1 - x)) / 2");
   ucDefineFunction("Acoth(x) = Log((x + 1) / (x - 1)) / 2");
   ucDefineFunction("Asech(x) = Log((1 + Sqr(1 - x ^ 2)) / x)");
   ucDefineFunction("Acsch(x) = Log(1 / x + Sqr(1 + x ^ 2) / Abs(x))");

   // A few constants needed in some definitions further down
   ucDefineConstant("Pi     = Atn(1) * 4");
   ucDefineConstant("HalfPI = Pi/2");

   // Other functions
   ucDefineFunction("Sec(x)   = 1 / Cos(x)");
   ucDefineFunction("Csc(x)   = 1 / Sin(x)");
   ucDefineFunction("Cot(x)   = 1 / Tan(x)");
   ucDefineFunction("Asin(x)  = SetOrFPU(4, Atn(x / Sqr(1 - x * x)))"); // +++ make provisions for complex
   ucDefineFunction("Acos(x)  = HalfPI - Asin(x)");
   ucDefineFunction("Log2(x)  = Log(x) / Log(2)");
   ucDefineFunction("Exp2(x)  = 2 ^ x");
   ucDefineFunction("Log10(x) = Log(x) / Log(10)");
   ucDefineFunction("Exp10(x) = 10 ^ x");

   // Complex operators & functions
   t.ucProperty.FunctionProperties = ucDynamic+ucLocked+ucOverride+ucOverload+ucComplex;
   ucDefineOperator("+[x] = x.Real + x.Imag*#i", Between_Mult_Pow);
   ucDefineOperator("-[x] = (-x.Real) + (-x.Imag)*#i", Between_Mult_Pow);

   ucDefineOperator("+[x,y] = x.Real+y.Real + (x.Imag+y.Imag)*#i", ucPrecedence("+"));
   ucDefineOperator("*[x,y] = (x.Real*y.Real - x.Imag*y.Imag)"
                    "+(x.Real*y.Imag + x.Imag*y.Real)*#i", ucPrecedence("*"));
   ucDefineOperator("-[x,y] = (x.Real-y.Real) + (x.Imag-y.Imag)*#i", ucPrecedence("-"));
   ucDefineOperator("/[x,y] = x.Real*y.Real/(y.Real^2+y.Imag^2)"
                    " + x.Imag*y.Imag/(y.Real^2+y.Imag^2)"
                    " + (x.Imag*y.Real/(y.Real^2+y.Imag^2)"
                    "-x.Real*y.Imag/(y.Real^2+y.Imag^2))*#i",
                    ucPrecedence("/"));

   t.ucProperty.FunctionProperties = ucDynamic+ucLocked+ucOverride+ucOverload+ucComplex;
   ucDefineFunction("Abs(x) = Sqr(x.Real^2 + x.Imag^2) + 0*#i");
   ucDefineFunction("Sgn(x) = x.Real/Abs(x) + x.Imag/Abs(x)*#i");   
   ucDefineFunction("Sin(x) = Sin(x.Real)*Cosh(x.Imag) + Cos(x.Real)*Sinh(x.Imag)*#i");
   ucDefineFunction("Cos(x) = Cos(x.Real)*Cosh(x.Imag) - Sin(x.Real)*Sinh(x.Imag)*#i");
   ucDefineFunction("Phase(x) = iif(x.Imag=0, iif(x.Real>0, 0, pi), atn(x.Imag/x.Real)) + 0*#i");
   ucDefineFunction("Conj(x)  = x.Real - x.Imag*#i");
   ucDefineFunction("Exp(x)   = Exp(x.Real)*Cos(x.Imag) + Exp(x.Real)*Sin(x.Imag)*#i");
   ucDefineFunction("Imag(x)  = x.Imag + 0*#i");
   ucDefineFunction("Real(x)  = x.Real + 0*#i");

   ucDefineFunction("Sqr(x)   = Sqr(Sqr(x.Real^2 + x.Imag^2)+x.Real)/Sqr(2)"
                    "+ (Sqr(Sqr(x.Real^2 + x.Imag^2)-x.Real)*iif(x.Imag < 0, -1, 1)/Sqr(2))*#i");
   ucDefineFunction("Sqrt(x)  = Sqr(x.Real+x.Imag*#i)");

   ucDefineFunction("Log(x) = iif(x.Real=0 and x.Imag=0, -Inf,"
                    "Log(x.Real^2 + x.Imag^2)/2)"
                    "+iif(x.Real=0 and x.Imag=0, 0, iif(x.Real>0 and x.Imag=0, 0,"
                    "iif(x.Imag=0, pi, pi*sgn(x.Imag)/2-Atn(x.Real/x.Imag))))*#i");

   ucDefineFunction("_ZeroToZero() = 1", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = 0", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = NaN", 0, ucDynamic+ucOverwrite);
// ucDefineFunction("_ZeroToZero() = SetError(1, '0^0 Error')", 0, ucDynamic+ucOverwrite);
   
   ucDefineOperator("^[x,y] = iif(x.Imag = 0, iif(x.Real > 0,"
   "x.Real^y.Real*Cos(y.Imag*Log(x.Real)),"
   "iif(x.Real=0 and y.Real=0 and y.Imag=0, _ZeroToZero(),"
   "(-x.Real)^y.Real*COS(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag))),"
   "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)"
   "*COS(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag"
   "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag))))-55+55"
   "+iif(x.Imag = 0, iif(x.Real > 0,"
   "x.Real^y.Real*SIN(y.Imag*LOG(x.Real)),"
   "iif(x.Real=0 and y.Real=0 and y.Imag=0, 0,"
   "(-x.Real)^y.Real*SIN(y.Imag*LOG(-x.Real)+pi*y.Real)/EXP(pi*y.Imag))),"
   "EXP(y.Imag*ATN(x.Real/x.Imag))*SQR((x.Imag^2+x.Real^2)^y.Real)"
   "*SIN(pi*y.Real*sgn(x.Imag)/2-y.Real*ATN(x.Real/x.Imag)+y.Imag"
   "*LOG(x.Imag^2+x.Real^2)/2)/SQR(EXP(pi*y.Imag*Sgn(x.Imag)))-55+55)*#i",
     ucPrecedence("^"));

   t.ucProperty.FunctionProperties = ucDynamic+ucOverload+ucOverwrite+ucComplex+ucRecursion;
   t.Context = t.Context ^ ucContext_ucReset;
   t.ucProperty.DefaultPrecedence = Between_Div_Mod; // arbitrarily chosen

#if defined(__BORLANDC__)
   t.ucProperty.DefaultNumericType = ucType_Extended;
#else
   t.ucProperty.DefaultNumericType = ucType_Double;
#endif
}

#ifndef ucAltErrMsg
char* ucGetErrorMessage(long ErrorNumber = -1, long t = 0)
{
   static char ErrMsg[80], ErrorMessage[80], ErrorNumberStr[80];

   if (ErrorNumber == -1) ErrorNumber = t0.ErrorNumber;

   switch(ErrorNumber)
   {
      case ucErr_None:                return ""; break; // No Error
      case ucErr_ucErrorData:         return ucGetErrorData(0, t); break;
      case ucErr_SyntaxError:         strcpy(ErrMsg, "Syntax error"); break;
      case ucErr_MismatchedParenth:   strcpy(ErrMsg, "Mismatched parenthesis"); break;
      case ucErr_MismatchedQuotes:    strcpy(ErrMsg, "Mismatched quotes"); break;
      case ucErr_UndefinedVariable:   strcpy(ErrMsg, "Undefined variable"); break;
      case ucErr_UndefinedFunction:   strcpy(ErrMsg, "Undefined function"); break;
      case ucErr_IncorrectArgType:    strcpy(ErrMsg, "Incorrect argument type"); break;
      case ucErr_InvalidNumberOfArgs: strcpy(ErrMsg, "Invalid number of function arguments"); break;
      case ucErr_InvalidOperandType:  strcpy(ErrMsg, "Invalid operand type"); break;
      case ucErr_InvalidVariableName: strcpy(ErrMsg, "Invalid variable name"); break;
      case ucErr_ImplicitMult:        strcpy(ErrMsg, "Implicit multiplication error"); break;
      case ucErr_IncompleteBlock:     strcpy(ErrMsg, "Incomplete syntax block"); break;

      case ucErr_InvalidOperation:    strcpy(ErrMsg, "Invalid floating point operation"); break;
      case ucErr_DenormalOperand:     strcpy(ErrMsg, "Denormal floating point operand"); break;
      case ucErr_DivisionByZero:      strcpy(ErrMsg, "Division by 0"); break;
      case ucErr_Overflow:            strcpy(ErrMsg, "Floating point overflow"); break;
      case ucErr_Underflow:           strcpy(ErrMsg, "Floating point underflow"); break;
      case ucErr_InexactResult:       strcpy(ErrMsg, "Inexact floating point result"); break;
      case ucErr_SubscriptOutOfRange: strcpy(ErrMsg, "Array subscript out of range"); break;
      case ucErr_StackOverflow:       strcpy(ErrMsg, "Stack overflow"); break;

      case ucErr_OperationDenied:     strcpy(ErrMsg, "Cannot perform requested operation"); break;
      case ucErr_PropertyConflict:    strcpy(ErrMsg, "Definition property conflict"); break;
      case ucErr_ConstantWriteDenied: strcpy(ErrMsg, "Assignment to a constant not allowed"); break;
      case ucErr_FunctionDefError:    strcpy(ErrMsg, "Invalid function or operator definition"); break;
      case ucErr_FunctionLocked:      strcpy(ErrMsg, "Function or operator is locked"); break;

      case ucErr_DefinitionSpaceFull: strcpy(ErrMsg, "Definition space is full"); break;
      case ucErr_ThreadInitFailed:    strcpy(ErrMsg, "Thread initialization failed"); break;
      case ucErr_UnsupportedFeature:  strcpy(ErrMsg, "Requires advanced edition of UCalc FMP"); break;
      default:                        strcpy(ErrMsg, "Unknown error");
      // numbers up to 500 are reserved for future use by UCalc
      // Use Case 501 and beyond for user-defined errors
   }

   itoa(ErrorNumber, ErrorNumberStr, 10);
   strcpy(ErrorMessage, "Error #");
   strcat(ErrorMessage, ErrorNumberStr);
   strcat(ErrorMessage, ": ");
   strcat(ErrorMessage, ErrMsg);
   
   return ErrorMessage;
}
#endif

char* ucErrorMessage(long ErrorNumber = -1, long t = 0)
{
   return ucGetErrorMessage(ErrorNumber, t);
}

